
module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | YIELDS
    | WHILE
    | VARLPAR of (
# 31 "src/lang/parser.mly"
       (string)
# 17 "src/lang/parser.ml"
  )
    | VARLBRA of (
# 32 "src/lang/parser.mly"
       (string)
# 22 "src/lang/parser.ml"
  )
    | VAR of (
# 30 "src/lang/parser.mly"
       (string)
# 27 "src/lang/parser.ml"
  )
    | UNDERSCORE
    | UMINUS
    | TRY
    | TO
    | TIMES
    | TIME of (
# 40 "src/lang/parser.mly"
       (int option list)
# 37 "src/lang/parser.ml"
  )
    | TILD
    | THEN
    | STRING of (
# 35 "src/lang/parser.mly"
       (string )
# 44 "src/lang/parser.ml"
  )
    | SLASH
    | SET
    | SEQSEQ
    | SEQ
    | RPAR
    | REPLACES
    | REGEXP of (
# 36 "src/lang/parser.mly"
       (string * char list )
# 55 "src/lang/parser.ml"
  )
    | RCUR
    | RBRA
    | QUESTION_DOT
    | QUESTION
    | PP_STRING of (
# 33 "src/lang/parser.mly"
       (string * Pos.t)
# 64 "src/lang/parser.ml"
  )
    | PP_REGEXP of (
# 34 "src/lang/parser.mly"
       (string * char list * Pos.t)
# 69 "src/lang/parser.ml"
  )
    | PP_INT_DOT_LCUR of (
# 37 "src/lang/parser.mly"
       (int)
# 74 "src/lang/parser.ml"
  )
    | PP_INCLUDE_EXTRA of (
# 76 "src/lang/parser.mly"
       (string)
# 79 "src/lang/parser.ml"
  )
    | PP_INCLUDE of (
# 77 "src/lang/parser.mly"
       (string)
# 84 "src/lang/parser.ml"
  )
    | PP_IFVERSION of (
# 71 "src/lang/parser.mly"
       ([ `Eq | `Geq | `Leq | `Gt | `Lt] * string)
# 89 "src/lang/parser.ml"
  )
    | PP_IFNENCODER
    | PP_IFNDEF of (
# 70 "src/lang/parser.mly"
       (string)
# 95 "src/lang/parser.ml"
  )
    | PP_IFENCODER
    | PP_IFDEF of (
# 70 "src/lang/parser.mly"
       (string)
# 101 "src/lang/parser.ml"
  )
    | PP_ENDL
    | PP_ENDIF
    | PP_ELSE
    | PP_DEFINE
    | PP_DEF of (
# 74 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 110 "src/lang/parser.ml"
  )
    | PP_COMMENT of (
# 78 "src/lang/parser.mly"
       (string list)
# 115 "src/lang/parser.ml"
  )
    | OPEN
    | NOT
    | MINUS
    | LPAR
    | LETLBRA of (
# 45 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 124 "src/lang/parser.ml"
  )
    | LET of (
# 44 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 129 "src/lang/parser.ml"
  )
    | LCUR
    | LBRA
    | INTERVAL of (
# 41 "src/lang/parser.mly"
       (int option list * int option list)
# 136 "src/lang/parser.ml"
  )
    | INT of (
# 37 "src/lang/parser.mly"
       (int)
# 141 "src/lang/parser.ml"
  )
    | IF
    | GETS
    | GET
    | FUN
    | FOR
    | FLOAT of (
# 38 "src/lang/parser.mly"
       (float)
# 151 "src/lang/parser.ml"
  )
    | EOF
    | END
    | ENCODER of (
# 42 "src/lang/parser.mly"
       (string)
# 158 "src/lang/parser.ml"
  )
    | ELSIF
    | ELSE
    | DOTVAR of (
# 57 "src/lang/parser.mly"
       (string)
# 165 "src/lang/parser.ml"
  )
    | DOTDOTDOT
    | DOT
    | DO
    | DEF of (
# 49 "src/lang/parser.mly"
       (Doc.Value.t option*Parser_helper.let_decoration)
# 173 "src/lang/parser.ml"
  )
    | COMMA
    | COLONCOLON
    | COLON
    | COALESCE
    | CATCH
    | BOOL of (
# 39 "src/lang/parser.mly"
       (bool)
# 183 "src/lang/parser.ml"
  )
    | BINB of (
# 61 "src/lang/parser.mly"
       (string)
# 188 "src/lang/parser.ml"
  )
    | BIN3 of (
# 64 "src/lang/parser.mly"
       (string)
# 193 "src/lang/parser.ml"
  )
    | BIN2 of (
# 63 "src/lang/parser.mly"
       (string)
# 198 "src/lang/parser.ml"
  )
    | BIN1 of (
# 62 "src/lang/parser.mly"
       (string)
# 203 "src/lang/parser.ml"
  )
    | BEGIN
    | ARGS_OF
  
end

include MenhirBasics

# 23 "src/lang/parser.mly"
  
open Term
open Term.Ground
(* All auxiliary functions for parser are there *)
open Parser_helper

# 219 "src/lang/parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_annotate) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: annotate. *)

  | MenhirState003 : (('s, _menhir_box_annotate) _menhir_cell1_annotate_metadata_entry, _menhir_box_annotate) _menhir_state
    (** State 003.
        Stack shape : annotate_metadata_entry.
        Start symbol: annotate. *)

  | MenhirState006 : (('s, _menhir_box_annotate) _menhir_cell1_annotate_key, _menhir_box_annotate) _menhir_state
    (** State 006.
        Stack shape : annotate_key.
        Start symbol: annotate. *)

  | MenhirState017 : ('s, _menhir_box_annotate_metadata_entry) _menhir_state
    (** State 017.
        Stack shape : .
        Start symbol: annotate_metadata_entry. *)

  | MenhirState020 : (('s, _menhir_box_annotate_metadata_entry) _menhir_cell1_annotate_key, _menhir_box_annotate_metadata_entry) _menhir_state
    (** State 020.
        Stack shape : annotate_key.
        Start symbol: annotate_metadata_entry. *)

  | MenhirState023 : ('s, _menhir_box_interactive) _menhir_state
    (** State 023.
        Stack shape : .
        Start symbol: interactive. *)

  | MenhirState025 : (('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_state
    (** State 025.
        Stack shape : WHILE.
        Start symbol: <undetermined>. *)

  | MenhirState026 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 026.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState027 : (('s, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 027.
        Stack shape : VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState029 : (('s, 'r) _menhir_cell1_UMINUS, 'r) _menhir_state
    (** State 029.
        Stack shape : UMINUS.
        Start symbol: <undetermined>. *)

  | MenhirState030 : (('s, 'r) _menhir_cell1_TRY, 'r) _menhir_state
    (** State 030.
        Stack shape : TRY.
        Start symbol: <undetermined>. *)

  | MenhirState036 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
    (** State 036.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

  | MenhirState037 : (('s, 'r) _menhir_cell1_NOT, 'r) _menhir_state
    (** State 037.
        Stack shape : NOT.
        Start symbol: <undetermined>. *)

  | MenhirState038 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 038.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState040 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 040.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState042 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 042.
        Stack shape : LCUR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState043 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 043.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState046 : (('s, 'r) _menhir_cell1_IF, 'r) _menhir_state
    (** State 046.
        Stack shape : IF.
        Start symbol: <undetermined>. *)

  | MenhirState047 : (('s, 'r) _menhir_cell1_LETLBRA, 'r) _menhir_state
    (** State 047.
        Stack shape : LETLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState049 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 049.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState050 : (('s, 'r) _menhir_cell1_GET, 'r) _menhir_state
    (** State 050.
        Stack shape : GET.
        Start symbol: <undetermined>. *)

  | MenhirState052 : (('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 052.
        Stack shape : FUN LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState055 : (('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_state
    (** State 055.
        Stack shape : TILD VAR.
        Start symbol: <undetermined>. *)

  | MenhirState056 : ((('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_cell1_GETS, 'r) _menhir_state
    (** State 056.
        Stack shape : TILD VAR GETS.
        Start symbol: <undetermined>. *)

  | MenhirState057 : (((('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_cell1_GETS, 'r) _menhir_cell1_UNDERSCORE, 'r) _menhir_state
    (** State 057.
        Stack shape : TILD VAR GETS UNDERSCORE.
        Start symbol: <undetermined>. *)

  | MenhirState058 : (('s, 'r) _menhir_cell1_GETS, 'r) _menhir_state
    (** State 058.
        Stack shape : GETS.
        Start symbol: <undetermined>. *)

  | MenhirState059 : (('s, 'r) _menhir_cell1_FOR, 'r) _menhir_state
    (** State 059.
        Stack shape : FOR.
        Start symbol: <undetermined>. *)

  | MenhirState061 : ((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 061.
        Stack shape : FOR optvar.
        Start symbol: <undetermined>. *)

  | MenhirState063 : (('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_state
    (** State 063.
        Stack shape : ENCODER.
        Start symbol: <undetermined>. *)

  | MenhirState064 : ((('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 064.
        Stack shape : ENCODER LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState066 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 066.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState068 : (('s, 'r) _menhir_cell1_BEGIN, 'r) _menhir_state
    (** State 068.
        Stack shape : BEGIN.
        Start symbol: <undetermined>. *)

  | MenhirState070 : (('s, 'r) _menhir_cell1_DEF, 'r) _menhir_state
    (** State 070.
        Stack shape : DEF.
        Start symbol: <undetermined>. *)

  | MenhirState073 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 073.
        Stack shape : DEF VAR.
        Start symbol: <undetermined>. *)

  | MenhirState075 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 075.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState078 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 078.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState080 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 080.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState082 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 082.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState085 : (('s, 'r) _menhir_cell1_UNDERSCORE, 'r) _menhir_state
    (** State 085.
        Stack shape : UNDERSCORE.
        Start symbol: <undetermined>. *)

  | MenhirState087 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 087.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState088 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 088.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState089 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 089.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState096 : (('s, 'r) _menhir_cell1_meth_pattern_el, 'r) _menhir_state
    (** State 096.
        Stack shape : meth_pattern_el.
        Start symbol: <undetermined>. *)

  | MenhirState099 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 099.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState100 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 100.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState104 : (('s, 'r) _menhir_cell1_tuple_pattern, 'r) _menhir_state
    (** State 104.
        Stack shape : tuple_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState107 : ((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_spread, 'r) _menhir_state
    (** State 107.
        Stack shape : LBRA spread.
        Start symbol: <undetermined>. *)

  | MenhirState111 : (('s, 'r) _menhir_cell1_pattern_list, 'r) _menhir_state
    (** State 111.
        Stack shape : pattern_list.
        Start symbol: <undetermined>. *)

  | MenhirState116 : (('s, 'r) _menhir_cell1_list_pattern, 'r) _menhir_state
    (** State 116.
        Stack shape : list_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState122 : ((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_pattern_list, 'r) _menhir_state
    (** State 122.
        Stack shape : LBRA pattern_list.
        Start symbol: <undetermined>. *)

  | MenhirState124 : (((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_pattern_list, 'r) _menhir_cell1_spread, 'r) _menhir_state
    (** State 124.
        Stack shape : LBRA pattern_list spread.
        Start symbol: <undetermined>. *)

  | MenhirState130 : (('s, 'r) _menhir_cell1_meth_pattern_el, 'r) _menhir_state
    (** State 130.
        Stack shape : meth_pattern_el.
        Start symbol: <undetermined>. *)

  | MenhirState132 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 132.
        Stack shape : DEF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState134 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 134.
        Stack shape : DEF LPAR pattern.
        Start symbol: <undetermined>. *)

  | MenhirState135 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 135.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState138 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 138.
        Stack shape : VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState151 : (('s, 'r) _menhir_cell1_ty_content_arg, 'r) _menhir_state
    (** State 151.
        Stack shape : ty_content_arg.
        Start symbol: <undetermined>. *)

  | MenhirState155 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 155.
        Stack shape : VAR VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState160 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 160.
        Stack shape : VAR VAR VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState165 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_ty_content, 'r) _menhir_state
    (** State 165.
        Stack shape : VAR ty_content.
        Start symbol: <undetermined>. *)

  | MenhirState173 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 173.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState175 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 175.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState176 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 176.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState179 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_QUESTION, 'r) _menhir_state
    (** State 179.
        Stack shape : VAR QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState180 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 180.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState191 : (('s, 'r) _menhir_cell1_ty _menhir_cell0_LCUR, 'r) _menhir_state
    (** State 191.
        Stack shape : ty LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState196 : (('s, 'r) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_QUESTION, 'r) _menhir_state
    (** State 196.
        Stack shape : STRING VAR VAR QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState198 : (('s, 'r) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR, 'r) _menhir_state
    (** State 198.
        Stack shape : STRING VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState203 : (('s, 'r) _menhir_cell1_meth_ty, 'r) _menhir_state
    (** State 203.
        Stack shape : meth_ty.
        Start symbol: <undetermined>. *)

  | MenhirState206 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 206.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState213 : (('s, 'r) _menhir_cell1_QUESTION _menhir_cell0_VAR, 'r) _menhir_state
    (** State 213.
        Stack shape : QUESTION VAR.
        Start symbol: <undetermined>. *)

  | MenhirState218 : (('s, 'r) _menhir_cell1_ty _menhir_cell0_TIMES, 'r) _menhir_state
    (** State 218.
        Stack shape : ty TIMES.
        Start symbol: <undetermined>. *)

  | MenhirState222 : (('s, 'r) _menhir_cell1_argty, 'r) _menhir_state
    (** State 222.
        Stack shape : argty.
        Start symbol: <undetermined>. *)

  | MenhirState227 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_argsty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 227.
        Stack shape : LPAR argsty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState230 : ((((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 230.
        Stack shape : DEF LPAR pattern ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState232 : (((((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 232.
        Stack shape : DEF LPAR pattern ty RPAR g.
        Start symbol: <undetermined>. *)

  | MenhirState236 : (('s, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 236.
        Stack shape : optvar.
        Start symbol: <undetermined>. *)

  | MenhirState237 : ((('s, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 237.
        Stack shape : optvar expr.
        Start symbol: <undetermined>. *)

  | MenhirState238 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TO, 'r) _menhir_state
    (** State 238.
        Stack shape : expr TO.
        Start symbol: <undetermined>. *)

  | MenhirState239 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TO, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 239.
        Stack shape : expr TO expr.
        Start symbol: <undetermined>. *)

  | MenhirState240 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TIMES, 'r) _menhir_state
    (** State 240.
        Stack shape : expr TIMES.
        Start symbol: <undetermined>. *)

  | MenhirState241 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TIMES, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 241.
        Stack shape : expr TIMES expr.
        Start symbol: <undetermined>. *)

  | MenhirState242 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_state
    (** State 242.
        Stack shape : expr DOT.
        Start symbol: <undetermined>. *)

  | MenhirState243 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 243.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState245 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 245.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState246 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 246.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState247 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_SET, 'r) _menhir_state
    (** State 247.
        Stack shape : expr SET.
        Start symbol: <undetermined>. *)

  | MenhirState248 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_SET, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 248.
        Stack shape : expr SET expr.
        Start symbol: <undetermined>. *)

  | MenhirState249 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION_DOT, 'r) _menhir_state
    (** State 249.
        Stack shape : expr QUESTION_DOT.
        Start symbol: <undetermined>. *)

  | MenhirState252 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_state
    (** State 252.
        Stack shape : expr QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState253 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 253.
        Stack shape : expr QUESTION expr.
        Start symbol: <undetermined>. *)

  | MenhirState254 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_MINUS, 'r) _menhir_state
    (** State 254.
        Stack shape : expr MINUS.
        Start symbol: <undetermined>. *)

  | MenhirState255 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_MINUS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 255.
        Stack shape : expr MINUS expr.
        Start symbol: <undetermined>. *)

  | MenhirState256 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLONCOLON, 'r) _menhir_state
    (** State 256.
        Stack shape : expr COLONCOLON.
        Start symbol: <undetermined>. *)

  | MenhirState257 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLONCOLON, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 257.
        Stack shape : expr COLONCOLON expr.
        Start symbol: <undetermined>. *)

  | MenhirState258 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN3, 'r) _menhir_state
    (** State 258.
        Stack shape : expr BIN3.
        Start symbol: <undetermined>. *)

  | MenhirState259 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN3, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 259.
        Stack shape : expr BIN3 expr.
        Start symbol: <undetermined>. *)

  | MenhirState260 : ((((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLON, 'r) _menhir_state
    (** State 260.
        Stack shape : expr QUESTION expr COLON.
        Start symbol: <undetermined>. *)

  | MenhirState262 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COALESCE, 'r) _menhir_state
    (** State 262.
        Stack shape : expr COALESCE.
        Start symbol: <undetermined>. *)

  | MenhirState263 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COALESCE, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 263.
        Stack shape : expr COALESCE expr.
        Start symbol: <undetermined>. *)

  | MenhirState264 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BINB, 'r) _menhir_state
    (** State 264.
        Stack shape : expr BINB.
        Start symbol: <undetermined>. *)

  | MenhirState265 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BINB, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 265.
        Stack shape : expr BINB expr.
        Start symbol: <undetermined>. *)

  | MenhirState266 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN2, 'r) _menhir_state
    (** State 266.
        Stack shape : expr BIN2.
        Start symbol: <undetermined>. *)

  | MenhirState267 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN2, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 267.
        Stack shape : expr BIN2 expr.
        Start symbol: <undetermined>. *)

  | MenhirState268 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN1, 'r) _menhir_state
    (** State 268.
        Stack shape : expr BIN1.
        Start symbol: <undetermined>. *)

  | MenhirState269 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN1, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 269.
        Stack shape : expr BIN1 expr.
        Start symbol: <undetermined>. *)

  | MenhirState271 : (('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 271.
        Stack shape : ARGS_OF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState272 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 272.
        Stack shape : ARGS_OF LPAR VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState274 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 274.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState277 : (('s, 'r) _menhir_cell1_GET _menhir_cell0_VAR, 'r) _menhir_state
    (** State 277.
        Stack shape : GET VAR.
        Start symbol: <undetermined>. *)

  | MenhirState285 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 285.
        Stack shape : ARGS_OF LPAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState288 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 288.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState291 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_subfield_lbra, 'r) _menhir_state
    (** State 291.
        Stack shape : ARGS_OF LPAR subfield_lbra.
        Start symbol: <undetermined>. *)

  | MenhirState297 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 297.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState299 : (('s, 'r) _menhir_cell1_app_list_elem, 'r) _menhir_state
    (** State 299.
        Stack shape : app_list_elem.
        Start symbol: <undetermined>. *)

  | MenhirState303 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 303.
        Stack shape : expr DOT VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState304 : ((((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 304.
        Stack shape : expr DOT VARLBRA expr.
        Start symbol: <undetermined>. *)

  | MenhirState306 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 306.
        Stack shape : expr DOT LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState312 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record _menhir_cell0_VAR, 'r) _menhir_state
    (** State 312.
        Stack shape : LCUR record VAR.
        Start symbol: <undetermined>. *)

  | MenhirState313 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record _menhir_cell0_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 313.
        Stack shape : LCUR record VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState317 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 317.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState319 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 319.
        Stack shape : expr s.
        Start symbol: <undetermined>. *)

  | MenhirState322 : (('s, 'r) _menhir_cell1_binding, 'r) _menhir_state
    (** State 322.
        Stack shape : binding.
        Start symbol: <undetermined>. *)

  | MenhirState323 : ((('s, 'r) _menhir_cell1_binding, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 323.
        Stack shape : binding s.
        Start symbol: <undetermined>. *)

  | MenhirState325 : (('s, 'r) _menhir_cell1__let, 'r) _menhir_state
    (** State 325.
        Stack shape : _let.
        Start symbol: <undetermined>. *)

  | MenhirState327 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 327.
        Stack shape : _let VAR.
        Start symbol: <undetermined>. *)

  | MenhirState329 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 329.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState330 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 330.
        Stack shape : _let LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState332 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 332.
        Stack shape : _let LPAR pattern.
        Start symbol: <undetermined>. *)

  | MenhirState335 : ((((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 335.
        Stack shape : _let LPAR pattern ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState336 : (((((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 336.
        Stack shape : _let LPAR pattern ty RPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState338 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_subfield, 'r) _menhir_state
    (** State 338.
        Stack shape : _let subfield.
        Start symbol: <undetermined>. *)

  | MenhirState339 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_subfield, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 339.
        Stack shape : _let subfield expr.
        Start symbol: <undetermined>. *)

  | MenhirState341 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 341.
        Stack shape : _let pattern.
        Start symbol: <undetermined>. *)

  | MenhirState342 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 342.
        Stack shape : _let pattern expr.
        Start symbol: <undetermined>. *)

  | MenhirState343 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_varlpar, 'r) _menhir_state
    (** State 343.
        Stack shape : DEF varlpar.
        Start symbol: <undetermined>. *)

  | MenhirState344 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 344.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState346 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 346.
        Stack shape : LPAR optvar.
        Start symbol: <undetermined>. *)

  | MenhirState348 : (((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 348.
        Stack shape : LPAR optvar ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState351 : (('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 351.
        Stack shape : ARGS_OF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState352 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 352.
        Stack shape : ARGS_OF LPAR VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState358 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_subfield_lbra, 'r) _menhir_state
    (** State 358.
        Stack shape : ARGS_OF LPAR subfield_lbra.
        Start symbol: <undetermined>. *)

  | MenhirState364 : (('s, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 364.
        Stack shape : optvar.
        Start symbol: <undetermined>. *)

  | MenhirState367 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_varlpar, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 367.
        Stack shape : DEF varlpar arglist RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState368 : ((((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_varlpar, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 368.
        Stack shape : DEF varlpar arglist RPAR g.
        Start symbol: <undetermined>. *)

  | MenhirState372 : (('s, 'r) _menhir_cell1_arg, 'r) _menhir_state
    (** State 372.
        Stack shape : arg.
        Start symbol: <undetermined>. *)

  | MenhirState374 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_subfield, 'r) _menhir_state
    (** State 374.
        Stack shape : DEF subfield.
        Start symbol: <undetermined>. *)

  | MenhirState375 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_subfield, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 375.
        Stack shape : DEF subfield g.
        Start symbol: <undetermined>. *)

  | MenhirState378 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 378.
        Stack shape : DEF pattern.
        Start symbol: <undetermined>. *)

  | MenhirState379 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 379.
        Stack shape : DEF pattern g.
        Start symbol: <undetermined>. *)

  | MenhirState384 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 384.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState386 : (('s, 'r) _menhir_cell1_STRING, 'r) _menhir_state
    (** State 386.
        Stack shape : STRING.
        Start symbol: <undetermined>. *)

  | MenhirState387 : ((('s, 'r) _menhir_cell1_STRING, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 387.
        Stack shape : STRING expr.
        Start symbol: <undetermined>. *)

  | MenhirState388 : (('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_state
    (** State 388.
        Stack shape : ENCODER.
        Start symbol: <undetermined>. *)

  | MenhirState393 : (('s, 'r) _menhir_cell1_encoder_param, 'r) _menhir_state
    (** State 393.
        Stack shape : encoder_param.
        Start symbol: <undetermined>. *)

  | MenhirState396 : (((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 396.
        Stack shape : FOR optvar expr.
        Start symbol: <undetermined>. *)

  | MenhirState397 : ((((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DO, 'r) _menhir_state
    (** State 397.
        Stack shape : FOR optvar expr DO.
        Start symbol: <undetermined>. *)

  | MenhirState400 : ((('s, 'r) _menhir_cell1_GETS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 400.
        Stack shape : GETS expr.
        Start symbol: <undetermined>. *)

  | MenhirState405 : (('s, 'r) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, 'r) _menhir_state
    (** State 405.
        Stack shape : TILD LPAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState407 : ((('s, 'r) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 407.
        Stack shape : TILD LPAR VAR ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState411 : ((('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 411.
        Stack shape : FUN LPAR arglist RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState412 : (((('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 412.
        Stack shape : FUN LPAR arglist RPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState413 : ((('s, 'r) _menhir_cell1_GET, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 413.
        Stack shape : GET expr.
        Start symbol: <undetermined>. *)

  | MenhirState414 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 414.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState416 : (('s, 'r) _menhir_cell1_let_opt_el, 'r) _menhir_state
    (** State 416.
        Stack shape : let_opt_el.
        Start symbol: <undetermined>. *)

  | MenhirState421 : ((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_state
    (** State 421.
        Stack shape : IF exprs THEN.
        Start symbol: <undetermined>. *)

  | MenhirState422 : (((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 422.
        Stack shape : IF exprs THEN exprs.
        Start symbol: <undetermined>. *)

  | MenhirState423 : (((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_state
    (** State 423.
        Stack shape : exprs THEN exprs ELSIF.
        Start symbol: <undetermined>. *)

  | MenhirState425 : ((((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_state
    (** State 425.
        Stack shape : exprs THEN exprs ELSIF exprs THEN.
        Start symbol: <undetermined>. *)

  | MenhirState426 : (((((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 426.
        Stack shape : exprs THEN exprs ELSIF exprs THEN exprs.
        Start symbol: <undetermined>. *)

  | MenhirState427 : (((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSE, 'r) _menhir_state
    (** State 427.
        Stack shape : exprs THEN exprs ELSE.
        Start symbol: <undetermined>. *)

  | MenhirState432 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 432.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState433 : ((('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 433.
        Stack shape : DOTDOTDOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState435 : (('s, 'r) _menhir_cell1_inner_list_item, 'r) _menhir_state
    (** State 435.
        Stack shape : inner_list_item.
        Start symbol: <undetermined>. *)

  | MenhirState437 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 437.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState440 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 440.
        Stack shape : LCUR VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState442 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
    (** State 442.
        Stack shape : LCUR OPEN.
        Start symbol: <undetermined>. *)

  | MenhirState443 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 443.
        Stack shape : LCUR OPEN expr.
        Start symbol: <undetermined>. *)

  | MenhirState444 : ((((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 444.
        Stack shape : LCUR OPEN expr s.
        Start symbol: <undetermined>. *)

  | MenhirState446 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 446.
        Stack shape : LCUR DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState447 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 447.
        Stack shape : LCUR DOTDOTDOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState454 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record _menhir_cell0_DOTDOTDOT, 'r) _menhir_state
    (** State 454.
        Stack shape : LCUR record DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState455 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_record _menhir_cell0_DOTDOTDOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 455.
        Stack shape : LCUR record DOTDOTDOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState457 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 457.
        Stack shape : LCUR expr.
        Start symbol: <undetermined>. *)

  | MenhirState458 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 458.
        Stack shape : LCUR expr s.
        Start symbol: <undetermined>. *)

  | MenhirState460 : ((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_explicit_binding, 'r) _menhir_state
    (** State 460.
        Stack shape : LCUR explicit_binding.
        Start symbol: <undetermined>. *)

  | MenhirState461 : (((('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_cell1_explicit_binding, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 461.
        Stack shape : LCUR explicit_binding s.
        Start symbol: <undetermined>. *)

  | MenhirState465 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 465.
        Stack shape : LPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState467 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 467.
        Stack shape : expr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState469 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 469.
        Stack shape : expr COMMA expr.
        Start symbol: <undetermined>. *)

  | MenhirState470 : (((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLON, 'r) _menhir_state
    (** State 470.
        Stack shape : LPAR expr COLON.
        Start symbol: <undetermined>. *)

  | MenhirState473 : ((('s, 'r) _menhir_cell1_NOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 473.
        Stack shape : NOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState474 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 474.
        Stack shape : OPEN expr.
        Start symbol: <undetermined>. *)

  | MenhirState475 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 475.
        Stack shape : OPEN expr s.
        Start symbol: <undetermined>. *)

  | MenhirState478 : ((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 478.
        Stack shape : TRY exprs.
        Start symbol: <undetermined>. *)

  | MenhirState480 : (((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 480.
        Stack shape : TRY exprs optvar.
        Start symbol: <undetermined>. *)

  | MenhirState483 : (((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 483.
        Stack shape : TRY exprs optvar.
        Start symbol: <undetermined>. *)

  | MenhirState485 : ((((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_varlist, 'r) _menhir_state
    (** State 485.
        Stack shape : TRY exprs optvar varlist.
        Start symbol: <undetermined>. *)

  | MenhirState489 : ((('s, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 489.
        Stack shape : VARLBRA expr.
        Start symbol: <undetermined>. *)

  | MenhirState493 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 493.
        Stack shape : WHILE expr.
        Start symbol: <undetermined>. *)

  | MenhirState494 : (((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DO, 'r) _menhir_state
    (** State 494.
        Stack shape : WHILE expr DO.
        Start symbol: <undetermined>. *)

  | MenhirState502 : ('s _menhir_cell0_LPAR, _menhir_box_plain_encoder_params) _menhir_state
    (** State 502.
        Stack shape : LPAR.
        Start symbol: plain_encoder_params. *)

  | MenhirState506 : ('s, _menhir_box_program) _menhir_state
    (** State 506.
        Stack shape : .
        Start symbol: program. *)

  | MenhirState512 : ('s, _menhir_box_time_predicate) _menhir_state
    (** State 512.
        Stack shape : .
        Start symbol: time_predicate. *)


and ('s, 'r) _menhir_cell1__let = 
  | MenhirCell1__let of 's * ('s, 'r) _menhir_state * (Parser_helper.let_decoration) * Lexing.position

and ('s, 'r) _menhir_cell1_annotate_key = 
  | MenhirCell1_annotate_key of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_annotate_metadata_entry = 
  | MenhirCell1_annotate_metadata_entry of 's * ('s, 'r) _menhir_state * (string * string)

and ('s, 'r) _menhir_cell1_app_list_elem = 
  | MenhirCell1_app_list_elem of 's * ('s, 'r) _menhir_state * (Parser_helper.app_list_elem)

and ('s, 'r) _menhir_cell1_arg = 
  | MenhirCell1_arg of 's * ('s, 'r) _menhir_state * (Parser_helper.arglist)

and ('s, 'r) _menhir_cell1_arglist = 
  | MenhirCell1_arglist of 's * ('s, 'r) _menhir_state * (Parser_helper.arglist)

and ('s, 'r) _menhir_cell1_argsty = 
  | MenhirCell1_argsty of 's * ('s, 'r) _menhir_state * ((bool * string * Type_base.t) list)

and ('s, 'r) _menhir_cell1_argty = 
  | MenhirCell1_argty of 's * ('s, 'r) _menhir_state * (bool * string * Type_base.t)

and ('s, 'r) _menhir_cell1_binding = 
  | MenhirCell1_binding of 's * ('s, 'r) _menhir_state * (Parser_helper.binding) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_encoder_param = 
  | MenhirCell1_encoder_param of 's * ('s, 'r) _menhir_state * (Parser_helper.encoder_param)

and ('s, 'r) _menhir_cell1_explicit_binding = 
  | MenhirCell1_explicit_binding of 's * ('s, 'r) _menhir_state * (Parser_helper.binding) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_expr = 
  | MenhirCell1_expr of 's * ('s, 'r) _menhir_state * (Term.term) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_exprs = 
  | MenhirCell1_exprs of 's * ('s, 'r) _menhir_state * (Term.term) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_g = 
  | MenhirCell1_g of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_inner_list_item = 
  | MenhirCell1_inner_list_item of 's * ('s, 'r) _menhir_state * (Parser_helper.inner_list_item) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_let_opt_el = 
  | MenhirCell1_let_opt_el of 's * ('s, 'r) _menhir_state * (Parser_helper.let_opt_el)

and ('s, 'r) _menhir_cell1_list_pattern = 
  | MenhirCell1_list_pattern of 's * ('s, 'r) _menhir_state * (Term.pattern)

and ('s, 'r) _menhir_cell1_meth_pattern_el = 
  | MenhirCell1_meth_pattern_el of 's * ('s, 'r) _menhir_state * (Parser_helper.meth_pattern_el)

and ('s, 'r) _menhir_cell1_meth_ty = 
  | MenhirCell1_meth_ty of 's * ('s, 'r) _menhir_state * (Parser_helper.meth_ty_opt) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_optvar = 
  | MenhirCell1_optvar of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_pattern = 
  | MenhirCell1_pattern of 's * ('s, 'r) _menhir_state * (Term.pattern)

and ('s, 'r) _menhir_cell1_pattern_list = 
  | MenhirCell1_pattern_list of 's * ('s, 'r) _menhir_state * (Term.pattern list)

and ('s, 'r) _menhir_cell1_record = 
  | MenhirCell1_record of 's * ('s, 'r) _menhir_state * (Parser_helper.record)

and ('s, 'r) _menhir_cell1_s = 
  | MenhirCell1_s of 's * ('s, 'r) _menhir_state * (unit) * Lexing.position

and ('s, 'r) _menhir_cell1_spread = 
  | MenhirCell1_spread of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_subfield = 
  | MenhirCell1_subfield of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_subfield_lbra = 
  | MenhirCell1_subfield_lbra of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_tuple_pattern = 
  | MenhirCell1_tuple_pattern of 's * ('s, 'r) _menhir_state * (Term.pattern)

and ('s, 'r) _menhir_cell1_ty = 
  | MenhirCell1_ty of 's * ('s, 'r) _menhir_state * (Type_base.t) * Lexing.position * Lexing.position

and 's _menhir_cell0_ty_content = 
  | MenhirCell0_ty_content of 's * (Parser_helper.ty_content)

and ('s, 'r) _menhir_cell1_ty_content_arg = 
  | MenhirCell1_ty_content_arg of 's * ('s, 'r) _menhir_state * (Parser_helper.ty_content_arg)

and ('s, 'r) _menhir_cell1_varlist = 
  | MenhirCell1_varlist of 's * ('s, 'r) _menhir_state * (Parser_helper.inner_list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_varlpar = 
  | MenhirCell1_varlpar of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_ARGS_OF = 
  | MenhirCell1_ARGS_OF of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BEGIN = 
  | MenhirCell1_BEGIN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BIN1 = 
  | MenhirCell1_BIN1 of 's * ('s, 'r) _menhir_state * (
# 62 "src/lang/parser.mly"
       (string)
# 1352 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BIN2 = 
  | MenhirCell1_BIN2 of 's * ('s, 'r) _menhir_state * (
# 63 "src/lang/parser.mly"
       (string)
# 1359 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BIN3 = 
  | MenhirCell1_BIN3 of 's * ('s, 'r) _menhir_state * (
# 64 "src/lang/parser.mly"
       (string)
# 1366 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BINB = 
  | MenhirCell1_BINB of 's * ('s, 'r) _menhir_state * (
# 61 "src/lang/parser.mly"
       (string)
# 1373 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_COALESCE = 
  | MenhirCell1_COALESCE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COLON = 
  | MenhirCell1_COLON of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COLONCOLON = 
  | MenhirCell1_COLONCOLON of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_COMMA = 
  | MenhirCell1_COMMA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DEF = 
  | MenhirCell1_DEF of 's * ('s, 'r) _menhir_state * (
# 49 "src/lang/parser.mly"
       (Doc.Value.t option*Parser_helper.let_decoration)
# 1392 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_DO = 
  | MenhirCell1_DO of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DOT = 
  | MenhirCell1_DOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DOTDOTDOT = 
  | MenhirCell1_DOTDOTDOT of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_DOTDOTDOT = 
  | MenhirCell0_DOTDOTDOT of 's * Lexing.position

and ('s, 'r) _menhir_cell1_ELSE = 
  | MenhirCell1_ELSE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ELSIF = 
  | MenhirCell1_ELSIF of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ENCODER = 
  | MenhirCell1_ENCODER of 's * ('s, 'r) _menhir_state * (
# 42 "src/lang/parser.mly"
       (string)
# 1417 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_FOR = 
  | MenhirCell1_FOR of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_FUN = 
  | MenhirCell1_FUN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_GET = 
  | MenhirCell1_GET of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_GETS = 
  | MenhirCell1_GETS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LBRA = 
  | MenhirCell1_LBRA of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LCUR = 
  | MenhirCell1_LCUR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LCUR = 
  | MenhirCell0_LCUR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_LETLBRA = 
  | MenhirCell1_LETLBRA of 's * ('s, 'r) _menhir_state * (
# 45 "src/lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 1448 "src/lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LPAR = 
  | MenhirCell0_LPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_MINUS = 
  | MenhirCell1_MINUS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_NOT = 
  | MenhirCell1_NOT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_OPEN = 
  | MenhirCell1_OPEN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_QUESTION = 
  | MenhirCell1_QUESTION of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_QUESTION = 
  | MenhirCell0_QUESTION of 's * Lexing.position

and ('s, 'r) _menhir_cell1_QUESTION_DOT = 
  | MenhirCell1_QUESTION_DOT of 's * ('s, 'r) _menhir_state

and 's _menhir_cell0_RPAR = 
  | MenhirCell0_RPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_SET = 
  | MenhirCell1_SET of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_STRING = 
  | MenhirCell1_STRING of 's * ('s, 'r) _menhir_state * (
# 35 "src/lang/parser.mly"
       (string )
# 1485 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_THEN = 
  | MenhirCell0_THEN of 's * Lexing.position

and ('s, 'r) _menhir_cell1_TILD = 
  | MenhirCell1_TILD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_TIMES = 
  | MenhirCell1_TIMES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_TIMES = 
  | MenhirCell0_TIMES of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TO = 
  | MenhirCell1_TO of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TRY = 
  | MenhirCell1_TRY of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_UMINUS = 
  | MenhirCell1_UMINUS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_UNDERSCORE = 
  | MenhirCell1_UNDERSCORE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VAR = 
  | MenhirCell1_VAR of 's * ('s, 'r) _menhir_state * (
# 30 "src/lang/parser.mly"
       (string)
# 1516 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_VAR = 
  | MenhirCell0_VAR of 's * (
# 30 "src/lang/parser.mly"
       (string)
# 1523 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VARLBRA = 
  | MenhirCell1_VARLBRA of 's * ('s, 'r) _menhir_state * (
# 32 "src/lang/parser.mly"
       (string)
# 1530 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VARLPAR = 
  | MenhirCell1_VARLPAR of 's * ('s, 'r) _menhir_state * (
# 31 "src/lang/parser.mly"
       (string)
# 1537 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_VARLPAR = 
  | MenhirCell0_VARLPAR of 's * (
# 31 "src/lang/parser.mly"
       (string)
# 1544 "src/lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_WHILE = 
  | MenhirCell1_WHILE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and _menhir_box_time_predicate = 
  | MenhirBox_time_predicate of (Term.term) [@@unboxed]

and _menhir_box_program = 
  | MenhirBox_program of (Term.term) [@@unboxed]

and _menhir_box_plain_encoder_params = 
  | MenhirBox_plain_encoder_params of (Parser_helper.encoder_opt) [@@unboxed]

and _menhir_box_interactive = 
  | MenhirBox_interactive of (Term.term) [@@unboxed]

and _menhir_box_annotate_metadata_entry = 
  | MenhirBox_annotate_metadata_entry of (string * string) [@@unboxed]

and _menhir_box_annotate = 
  | MenhirBox_annotate of ((string * string) list) [@@unboxed]

let _menhir_action_006 =
  fun _1 ->
    (
# 486 "src/lang/parser.mly"
        ( Parser_helper.let_decoration_of_lexer_let_decoration _1 )
# 1573 "src/lang/parser.ml"
     : (Parser_helper.let_decoration))

let _menhir_action_007 =
  fun _1 _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 487 "src/lang/parser.mly"
                         (
      match _1 with
        | `Json_parse     -> `Json_parse (Parser_helper.args_of_json_parse ~pos:_loc _2)
        | _ -> raise (Parse_error (_loc, "Invalid let constructor")) )
# 1587 "src/lang/parser.ml"
     : (Parser_helper.let_decoration))

let _menhir_action_008 =
  fun _1 ->
    (
# 581 "src/lang/parser.mly"
                            ( _1 )
# 1595 "src/lang/parser.ml"
     : ((string * string) list))

let _menhir_action_009 =
  fun _1 ->
    (
# 591 "src/lang/parser.mly"
        ( _1 )
# 1603 "src/lang/parser.ml"
     : (string))

let _menhir_action_010 =
  fun _1 ->
    (
# 592 "src/lang/parser.mly"
           ( _1 )
# 1611 "src/lang/parser.ml"
     : (string))

let _menhir_action_011 =
  fun _1 _2 ->
    (
# 584 "src/lang/parser.mly"
                                              ( _1::_2 )
# 1619 "src/lang/parser.ml"
     : ((string * string) list))

let _menhir_action_012 =
  fun _1 _3 ->
    (
# 585 "src/lang/parser.mly"
                                     ( [_1, _3] )
# 1627 "src/lang/parser.ml"
     : ((string * string) list))

let _menhir_action_013 =
  fun _1 _3 ->
    (
# 588 "src/lang/parser.mly"
                                           ( _1, _3 )
# 1635 "src/lang/parser.ml"
     : (string * string))

let _menhir_action_014 =
  fun _1 ->
    (
# 595 "src/lang/parser.mly"
        ( string_of_int _1 )
# 1643 "src/lang/parser.ml"
     : (string))

let _menhir_action_015 =
  fun _1 ->
    (
# 596 "src/lang/parser.mly"
          ( string_of_float _1 )
# 1651 "src/lang/parser.ml"
     : (string))

let _menhir_action_016 =
  fun _1 ->
    (
# 597 "src/lang/parser.mly"
         ( string_of_bool _1 )
# 1659 "src/lang/parser.ml"
     : (string))

let _menhir_action_017 =
  fun _1 ->
    (
# 598 "src/lang/parser.mly"
        ( _1 )
# 1667 "src/lang/parser.ml"
     : (string))

let _menhir_action_018 =
  fun _1 ->
    (
# 599 "src/lang/parser.mly"
           ( _1 )
# 1675 "src/lang/parser.ml"
     : (string))

let _menhir_action_019 =
  fun () ->
    (
# 403 "src/lang/parser.mly"
                                 ( [] )
# 1683 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_020 =
  fun _1 ->
    (
# 404 "src/lang/parser.mly"
                                 ( _1 )
# 1691 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_021 =
  fun _1 _3 ->
    (
# 405 "src/lang/parser.mly"
                                 ( _1@_3 )
# 1699 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_022 =
  fun _1 _3 ->
    (
# 394 "src/lang/parser.mly"
                  ( [_1,_3] )
# 1707 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_023 =
  fun _1 ->
    (
# 395 "src/lang/parser.mly"
                  ( ["",_1] )
# 1715 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_024 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 396 "src/lang/parser.mly"
                                 ( app_of ~only:[] ~except:[] ~pos:_loc _3 )
# 1726 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_025 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 398 "src/lang/parser.mly"
                                 ( app_of ~only:[] ~except:[] ~pos:_loc (String.concat "." _3) )
# 1737 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_026 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 399 "src/lang/parser.mly"
                                                  ( app_of ~pos:_loc ~only:(fst _4) ~except:(snd _4) _3 )
# 1748 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_027 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 401 "src/lang/parser.mly"
                                 ( app_of ~pos:_loc (String.concat "." _3) ~only:(fst _4) ~except:(snd _4) )
# 1759 "src/lang/parser.ml"
     : (Parser_helper.app_list_elem))

let _menhir_action_028 =
  fun _2 _3 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 517 "src/lang/parser.mly"
                 ( [_2, _2, Type.var ~pos:_loc__2_ (), _3] )
# 1768 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_029 =
  fun _3 _5 _7 ->
    (
# 518 "src/lang/parser.mly"
                                    ( [_3, _3, _5, _7 ] )
# 1776 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_030 =
  fun _2 _5 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 519 "src/lang/parser.mly"
                                 ( [_2, "_", Type.var ~pos:_loc__2_ (), _5] )
# 1785 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_031 =
  fun _1 _2 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 520 "src/lang/parser.mly"
                ( ["", _1, Type.var ~pos:_loc__1_ (), _2] )
# 1794 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_032 =
  fun _2 _4 _6 ->
    (
# 521 "src/lang/parser.mly"
                                  ( ["", _2, _4, _6] )
# 1802 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_033 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 522 "src/lang/parser.mly"
                          ( args_of ~only:[] ~except:[] ~pos:_loc _3 )
# 1813 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_034 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 524 "src/lang/parser.mly"
                          ( args_of ~only:[] ~except:[] ~pos:_loc (String.concat "." _3) )
# 1824 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_035 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 525 "src/lang/parser.mly"
                                                  ( args_of ~pos:_loc ~only:(fst _4) ~except:(snd _4) _3 )
# 1835 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_036 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 527 "src/lang/parser.mly"
                          ( args_of ~pos:_loc (String.concat "." _3) ~only:(fst _4) ~except:(snd _4) )
# 1846 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_037 =
  fun () ->
    (
# 513 "src/lang/parser.mly"
                          ( [] )
# 1854 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_038 =
  fun _1 ->
    (
# 514 "src/lang/parser.mly"
                          ( _1 )
# 1862 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_039 =
  fun _1 _3 ->
    (
# 515 "src/lang/parser.mly"
                          ( _1@_3 )
# 1870 "src/lang/parser.ml"
     : (Parser_helper.arglist))

let _menhir_action_040 =
  fun _1 ->
    (
# 532 "src/lang/parser.mly"
                                 ( [_1], [] )
# 1878 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_041 =
  fun _2 ->
    (
# 533 "src/lang/parser.mly"
                                 ( [], [_2] )
# 1886 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_042 =
  fun _1 _3 ->
    (
# 534 "src/lang/parser.mly"
                                 ( _1::(fst _3), (snd _3) )
# 1894 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_043 =
  fun _2 _4 ->
    (
# 535 "src/lang/parser.mly"
                                 ( (fst _4), _2::(snd _4) )
# 1902 "src/lang/parser.ml"
     : (string list * string list))

let _menhir_action_044 =
  fun () ->
    (
# 373 "src/lang/parser.mly"
                       ( [] )
# 1910 "src/lang/parser.ml"
     : ((bool * string * Type_base.t) list))

let _menhir_action_045 =
  fun _1 ->
    (
# 374 "src/lang/parser.mly"
                       ( [_1] )
# 1918 "src/lang/parser.ml"
     : ((bool * string * Type_base.t) list))

let _menhir_action_046 =
  fun _1 _3 ->
    (
# 375 "src/lang/parser.mly"
                       ( _1::_3 )
# 1926 "src/lang/parser.ml"
     : ((bool * string * Type_base.t) list))

let _menhir_action_047 =
  fun _1 ->
    (
# 368 "src/lang/parser.mly"
                          ( false,"",_1 )
# 1934 "src/lang/parser.ml"
     : (bool * string * Type_base.t))

let _menhir_action_048 =
  fun _1 _3 ->
    (
# 369 "src/lang/parser.mly"
                          ( false,_1,_3 )
# 1942 "src/lang/parser.ml"
     : (bool * string * Type_base.t))

let _menhir_action_049 =
  fun _2 _4 ->
    (
# 370 "src/lang/parser.mly"
                          ( true,_2,_4 )
# 1950 "src/lang/parser.ml"
     : (bool * string * Type_base.t))

let _menhir_action_050 =
  fun _1 _3 ->
    (
# 505 "src/lang/parser.mly"
                             ( Parser_helper.let_args ~decoration:`None ~pat:(PVar [_1]) ~def:_3 () )
# 1958 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_051 =
  fun _1 ->
    (
# 506 "src/lang/parser.mly"
                             ( _1 )
# 1966 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_052 =
  fun () ->
    (
# 552 "src/lang/parser.mly"
                 ( [] )
# 1974 "src/lang/parser.ml"
     : (Parser_helper.encoder_opt))

let _menhir_action_053 =
  fun _2 ->
    (
# 553 "src/lang/parser.mly"
                             ( _2 )
# 1982 "src/lang/parser.ml"
     : (Parser_helper.encoder_opt))

let _menhir_action_054 =
  fun _1 _3 ->
    (
# 556 "src/lang/parser.mly"
                        ( _1, `Term _3 )
# 1990 "src/lang/parser.ml"
     : (Parser_helper.encoder_param))

let _menhir_action_055 =
  fun _1 _3 ->
    (
# 557 "src/lang/parser.mly"
                        ( _1, `Term _3 )
# 1998 "src/lang/parser.ml"
     : (Parser_helper.encoder_param))

let _menhir_action_056 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 558 "src/lang/parser.mly"
                        ( "", `Term (mk ~pos:_loc (Ground (String _1))) )
# 2009 "src/lang/parser.ml"
     : (Parser_helper.encoder_param))

let _menhir_action_057 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 559 "src/lang/parser.mly"
                        ( "", `Term (mk ~pos:_loc (Ground (String _1))) )
# 2020 "src/lang/parser.ml"
     : (Parser_helper.encoder_param))

let _menhir_action_058 =
  fun _1 _2 ->
    (
# 560 "src/lang/parser.mly"
                        ( "", `Encoder (_1, _2) )
# 2028 "src/lang/parser.ml"
     : (Parser_helper.encoder_param))

let _menhir_action_059 =
  fun () ->
    (
# 563 "src/lang/parser.mly"
                                       ( [] )
# 2036 "src/lang/parser.ml"
     : (Parser_helper.encoder_opt))

let _menhir_action_060 =
  fun _1 ->
    (
# 564 "src/lang/parser.mly"
                                       ( [_1] )
# 2044 "src/lang/parser.ml"
     : (Parser_helper.encoder_opt))

let _menhir_action_061 =
  fun _1 _3 ->
    (
# 565 "src/lang/parser.mly"
                                       ( _1::_3 )
# 2052 "src/lang/parser.ml"
     : (Parser_helper.encoder_opt))

let _menhir_action_062 =
  fun _1 _2 _4 ->
    (
# 493 "src/lang/parser.mly"
                             ( Parser_helper.let_args ~decoration:_1 ~pat:_2 ~def:_4 () )
# 2060 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_063 =
  fun _1 _3 _5 _8 ->
    (
# 495 "src/lang/parser.mly"
                             ( Parser_helper.let_args ~decoration:_1 ~pat:_3 ~def:_8 ~cast:_5 () )
# 2068 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_064 =
  fun _1 _2 _4 ->
    (
# 496 "src/lang/parser.mly"
                             ( Parser_helper.let_args ~decoration:_1 ~pat:(PVar _2) ~def:_4 () )
# 2076 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_065 =
  fun _1 _2 _4 ->
    (
# 497 "src/lang/parser.mly"
                             ( Parser_helper.let_args ?doc:(fst _1) ~decoration:(snd _1) ~pat:_2 ~def:_4 () )
# 2084 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_066 =
  fun _1 _3 _5 _8 ->
    (
# 499 "src/lang/parser.mly"
                             ( Parser_helper.let_args ?doc:(fst _1) ~decoration:(snd _1) ~pat:_3 ~def:_8 ~cast:_5 () )
# 2092 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_067 =
  fun _1 _2 _4 ->
    (
# 500 "src/lang/parser.mly"
                             ( Parser_helper.let_args ?doc:(fst _1) ~decoration:(snd _1) ~pat:(PVar _2) ~def:_4 () )
# 2100 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_068 =
  fun _1 _2 _3 _6 ->
    (
# 502 "src/lang/parser.mly"
                             ( Parser_helper.let_args ?doc:(fst _1) ~decoration:(snd _1) ~pat:(PVar _2) ~arglist:_3 ~def:_6 () )
# 2108 "src/lang/parser.ml"
     : (Parser_helper.binding))

let _menhir_action_069 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 210 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Cast (_2, _4)) )
# 2119 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_070 =
  fun _2 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 211 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "~-"), ["", _2])) )
# 2131 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_071 =
  fun _2 ->
    (
# 212 "src/lang/parser.mly"
                                     ( _2 )
# 2139 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_072 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 213 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Int _1)) )
# 2150 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_073 =
  fun _2 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 214 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "not"), ["", _2])) )
# 2162 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_074 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 215 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Bool _1)) )
# 2173 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_075 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 216 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Float  _1)) )
# 2184 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_076 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 217 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (String _1)) )
# 2195 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_077 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 218 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Var _1) )
# 2206 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_078 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 219 "src/lang/parser.mly"
                                     ( mk_list ~pos:_loc _1 )
# 2217 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_079 =
  fun _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 220 "src/lang/parser.mly"
                                     ( Printf.eprintf "Warning, %s: the notation !x for references is deprecated, please use x() instead.\n%!" (Pos.to_string _loc); mk ~pos:_loc (App (_2, [])) )
# 2228 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_080 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 221 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Invoke {invoked = _1; default = None; meth = "set"}), ["", _3])) )
# 2240 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_081 =
  fun _1 _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 222 "src/lang/parser.mly"
                                     ( mk_encoder ~pos:_loc _1 _2 )
# 2251 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_082 =
  fun _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 223 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Tuple []) )
# 2262 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_083 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 224 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Tuple _2) )
# 2273 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_084 =
  fun _1 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 225 "src/lang/parser.mly"
                                     ( _4 ~pos:_loc _1 )
# 2284 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_085 =
  fun _3 ->
    (
# 226 "src/lang/parser.mly"
                                     ( _3 )
# 2292 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_086 =
  fun _2 _5 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 228 "src/lang/parser.mly"
                                     ( _2 ~pos:_loc _5 )
# 2303 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_087 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 229 "src/lang/parser.mly"
                                     ( _2 ~pos:_loc (mk ~pos:_loc (Tuple [])) )
# 2314 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_088 =
  fun _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 230 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (Tuple []) )
# 2325 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_089 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 231 "src/lang/parser.mly"
                                     ( mk_invoke ~pos:_loc ~default:(mk ~pos:_loc Null) _1 _3 )
# 2336 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_090 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 232 "src/lang/parser.mly"
                                     ( mk_invoke ~pos:_loc _1 _3 )
# 2347 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_091 =
  fun _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 233 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var _1), _2)) )
# 2359 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_092 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 234 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var "_::_"), ["", _1; "", _3])) )
# 2371 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_093 =
  fun _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 235 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc (Var "_[_]"), ["", mk ~pos:_loc__1_ (Var _1); "", _2])) )
# 2383 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_094 =
  fun _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 236 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc (Var "_[_]"), ["", mk ~pos:(_startpos__1_,_endpos__3_) (Invoke ({invoked = _1; default = None; meth =  _3})); "", _4])) )
# 2394 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_095 =
  fun _2 ->
    (
# 237 "src/lang/parser.mly"
                                     ( _2 )
# 2402 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_096 =
  fun _3 _6 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 238 "src/lang/parser.mly"
                                     ( mk_fun ~pos:_loc _3 _6 )
# 2413 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_097 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 239 "src/lang/parser.mly"
                                     ( mk_fun ~pos:_loc [] _2 )
# 2424 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_098 =
  fun _2 _4 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__2_ _startpos__4_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 240 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "while"), ["", mk_fun ~pos:_loc__2_ [] _2; "", mk_fun ~pos:_loc__4_ [] _4])) )
# 2438 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_099 =
  fun _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__6_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 242 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "for"), ["", _4; "", mk_fun ~pos:_loc__6_ ["", _2, Type.var ~pos:_loc__2_ (), None] _6])) )
# 2452 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_100 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 243 "src/lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Invoke ({invoked = mk ~pos:_loc__2_ (Var "iterator"); default = None; meth = "int"})), ["", _1; "", _3])) )
# 2464 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_101 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 244 "src/lang/parser.mly"
                                     ( Parser_helper.mk_coalesce ~pos:_loc ~default:_3 _1 )
# 2475 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_102 =
  fun _2 _4 _6 _8 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__8_ _endpos__9_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__8_ ->
    let _endpos = _endpos__9_ in
    let _startpos = _startpos__1_ in
    let _loc__8_ = (_startpos__8_, _endpos__8_) in
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 246 "src/lang/parser.mly"
                                     ( let fn = mk_fun ~pos:_loc__2_ [] _2 in
                                       let err_arg = ["", _4, Type.var ~pos:_loc__4_ (), None] in
                                       let errors = mk_list ~pos:_loc _6 in
                                       let handler =  mk_fun ~pos:_loc__8_ err_arg _8 in
                                       let error_module = mk ~pos:_loc__1_ (Var "error") in
                                       let op = mk ~pos:_loc__1_ (Invoke ({invoked = error_module; default = None; meth =  "catch"})) in
                                       mk ~pos:_loc (App (op, ["errors", errors; "", fn; "", handler])) )
# 2496 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_103 =
  fun _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__6_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 253 "src/lang/parser.mly"
                                        ( let fn = mk_fun ~pos:_loc__2_ [] _2 in
                                       let err_arg = ["", _4, Type.var ~pos:_loc__4_ (), None] in
                                       let handler = mk_fun ~pos:_loc__6_ err_arg _6 in
                                       let errors = mk ~pos:_loc Null in
                                       let error_module = mk ~pos:_loc__1_ (Var "error") in
                                       let op = mk ~pos:_loc__1_ (Invoke ({invoked = error_module; default = None; meth = "catch"})) in
                                       mk ~pos:_loc (App (op, ["errors", errors; "", fn; "", handler])) )
# 2517 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_104 =
  fun _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__6_ _startpos__1_ _startpos__3_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 260 "src/lang/parser.mly"
                                     ( let cond = _2 in
                                       let then_b = mk_fun ~pos:(_startpos__3_,_endpos__4_) [] _4 in
                                       let else_b = _5 in
                                       let op = mk ~pos:_loc__1_ (Var "if") in
                                       mk ~pos:_loc (App (op, ["", cond; "then", then_b; "else", else_b])) )
# 2533 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_105 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 265 "src/lang/parser.mly"
                                    (  let regexp, flags = _1 in
                                       let regexp =  mk ~pos:_loc (Ground (String regexp)) in
                                       let flags = List.map Char.escaped flags in
                                       let flags = List.map (fun s -> mk ~pos:_loc (Ground (String s))) flags in
                                       let flags = mk ~pos:_loc (List flags) in
                                       let op = mk ~pos:_loc__1_ (Var "regexp") in
                                       mk ~pos:_loc (App (op, ["", regexp; "flags", flags])) )
# 2551 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_106 =
  fun _1 _3 _5 _endpos__1_ _endpos__3_ _endpos__5_ _startpos__1_ _startpos__3_ _startpos__5_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc__5_ = (_startpos__5_, _endpos__5_) in
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 272 "src/lang/parser.mly"
                                     ( let cond = _1 in
                                       let then_b = mk_fun ~pos:_loc__3_ [] _3 in
                                       let else_b = mk_fun ~pos:_loc__5_ [] _5 in
                                       let op = mk ~pos:_loc__1_ (Var "if") in
                                       mk ~pos:_loc (App (op, ["", cond; "then", then_b; "else", else_b])) )
# 2569 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_107 =
  fun _1 _2 _3 _endpos__1_ _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ _startpos__3_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 278 "src/lang/parser.mly"
                                   ( let left = mk_fun ~pos:_loc__1_ [] _1 in
                                     let right= mk_fun ~pos:_loc__3_ [] _3 in
                                     mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",left;"",right])) )
# 2585 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_108 =
  fun _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 281 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",_1;"",_3])) )
# 2597 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_109 =
  fun _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 282 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",_1;"",_3])) )
# 2609 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_110 =
  fun _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 283 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",_1;"",_3])) )
# 2621 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_111 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 284 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var "*"), ["",_1;"",_3])) )
# 2633 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_112 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 285 "src/lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var "-"), ["",_1;"",_3])) )
# 2645 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_113 =
  fun _1 ->
    (
# 286 "src/lang/parser.mly"
                                   ( _1 )
# 2653 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_114 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 193 "src/lang/parser.mly"
                             ( mk ~pos:_loc (Open (_2,_4)) )
# 2664 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_115 =
  fun _1 ->
    (
# 194 "src/lang/parser.mly"
                             ( _1 )
# 2672 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_116 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 195 "src/lang/parser.mly"
                             ( mk ~pos:_loc (Seq (_1,_3)) )
# 2683 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_117 =
  fun _1 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 196 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 (mk ~pos:_loc unit) )
# 2695 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_118 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 197 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 _3 )
# 2704 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_119 =
  fun () ->
    (
# 190 "src/lang/parser.mly"
     ()
# 2712 "src/lang/parser.ml"
     : (unit))

let _menhir_action_120 =
  fun () ->
    (
# 190 "src/lang/parser.mly"
               ()
# 2720 "src/lang/parser.ml"
     : (unit))

let _menhir_action_121 =
  fun _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__3_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 543 "src/lang/parser.mly"
                                    ( let cond = _2 in
                                      let then_b = mk_fun ~pos:(_startpos__3_, _endpos__4_) [] _4 in
                                      let else_b = _5 in
                                      let op = mk ~pos:_loc__1_ (Var "if") in
                                      mk_fun ~pos:_loc [] (mk ~pos:_loc (App (op,["",cond; "then",then_b; "else",else_b]))) )
# 2736 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_122 =
  fun _2 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 548 "src/lang/parser.mly"
                                    ( mk_fun ~pos:_loc__2_ [] _2 )
# 2745 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_123 =
  fun _endpos__0_ ->
    let _endpos = _endpos__0_ in
    let _startpos = _endpos__0_ in
    let _loc = (_startpos, _endpos) in
    (
# 549 "src/lang/parser.mly"
                                    ( mk_fun ~pos:_loc [] (mk ~pos:_loc unit) )
# 2756 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_124 =
  fun _1 ->
    (
# 474 "src/lang/parser.mly"
                        ( [_1] )
# 2764 "src/lang/parser.ml"
     : (string list))

let _menhir_action_125 =
  fun _1 _3 ->
    (
# 475 "src/lang/parser.mly"
                        ( _1::_3 )
# 2772 "src/lang/parser.ml"
     : (string list))

let _menhir_action_126 =
  fun _1 ->
    (
# 539 "src/lang/parser.mly"
            ( [_1] )
# 2780 "src/lang/parser.ml"
     : (string list))

let _menhir_action_127 =
  fun _1 _3 ->
    (
# 540 "src/lang/parser.mly"
                             ( _1::_3 )
# 2788 "src/lang/parser.ml"
     : (string list))

let _menhir_action_128 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 381 "src/lang/parser.mly"
                          ( append_list ~pos:_loc _1 _3 )
# 2799 "src/lang/parser.ml"
     : (Parser_helper.inner_list))

let _menhir_action_129 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 382 "src/lang/parser.mly"
                          ( append_list ~pos:_loc _1 (`List []) )
# 2810 "src/lang/parser.ml"
     : (Parser_helper.inner_list))

let _menhir_action_130 =
  fun () ->
    (
# 383 "src/lang/parser.mly"
                          ( `List [] )
# 2818 "src/lang/parser.ml"
     : (Parser_helper.inner_list))

let _menhir_action_131 =
  fun _2 ->
    (
# 386 "src/lang/parser.mly"
                   ( `Ellipsis _2 )
# 2826 "src/lang/parser.ml"
     : (Parser_helper.inner_list_item))

let _menhir_action_132 =
  fun _1 ->
    (
# 387 "src/lang/parser.mly"
                   ( `Expr _1 )
# 2834 "src/lang/parser.ml"
     : (Parser_helper.inner_list_item))

let _menhir_action_133 =
  fun _1 _3 ->
    (
# 390 "src/lang/parser.mly"
                    ( [_1;_3] )
# 2842 "src/lang/parser.ml"
     : (Term.term list))

let _menhir_action_134 =
  fun _1 _3 ->
    (
# 391 "src/lang/parser.mly"
                           ( _1::_3 )
# 2850 "src/lang/parser.ml"
     : (Term.term list))

let _menhir_action_135 =
  fun _endpos__1_ _startpos__1_ ->
    let _ = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 185 "src/lang/parser.mly"
          ( raise (Parse_error (_loc, "Syntax error!")) )
# 2861 "src/lang/parser.ml"
     : (Term.term)) in
    prerr_string "Menhir: misuse: the semantic action associated with the production\ninteractive -> error\nis expected to abort the parser, but does not do so.\n";
    assert false

let _menhir_action_136 =
  fun _1 ->
    (
# 186 "src/lang/parser.mly"
                 ( _1 )
# 2871 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_137 =
  fun () ->
    (
# 187 "src/lang/parser.mly"
        ( raise End_of_file )
# 2879 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_138 =
  fun _1 ->
    (
# 289 "src/lang/parser.mly"
                          ( `String _1 )
# 2887 "src/lang/parser.ml"
     : ([ `App of string * Parser_helper.app_list_elem | `String of string ]))

let _menhir_action_139 =
  fun _1 _2 ->
    (
# 290 "src/lang/parser.mly"
                          ( `App (_1, _2) )
# 2895 "src/lang/parser.ml"
     : ([ `App of string * Parser_helper.app_list_elem | `String of string ]))

let _menhir_action_140 =
  fun _1 ->
    (
# 482 "src/lang/parser.mly"
                             ( [_1] )
# 2903 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el list))

let _menhir_action_141 =
  fun _1 _3 ->
    (
# 483 "src/lang/parser.mly"
                             ( _1::_3 )
# 2911 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el list))

let _menhir_action_142 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 478 "src/lang/parser.mly"
                  ( _1, mk ~pos:_loc (Var _1) )
# 2922 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el))

let _menhir_action_143 =
  fun _1 _3 ->
    (
# 479 "src/lang/parser.mly"
                  ( _1, _3 )
# 2930 "src/lang/parser.ml"
     : (Parser_helper.let_opt_el))

let _menhir_action_144 =
  fun _2 ->
    (
# 431 "src/lang/parser.mly"
                                       ( PList _2 )
# 2938 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_145 =
  fun _1 ->
    (
# 454 "src/lang/parser.mly"
                                     ( PMeth _1                      )
# 2946 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_146 =
  fun _1 ->
    (
# 455 "src/lang/parser.mly"
                                     ( PMeth (None,              _1) )
# 2954 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_147 =
  fun _1 _3 ->
    (
# 456 "src/lang/parser.mly"
                                     ( PMeth (Some (PVar [_1]),  _3) )
# 2962 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_148 =
  fun _3 ->
    (
# 457 "src/lang/parser.mly"
                                     ( PMeth (Some (PVar ["_"]), _3) )
# 2970 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_149 =
  fun _1 _3 ->
    (
# 458 "src/lang/parser.mly"
                                     ( PMeth (Some _1,           _3) )
# 2978 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_150 =
  fun _1 _3 ->
    (
# 459 "src/lang/parser.mly"
                                     ( PMeth (Some _1,           _3) )
# 2986 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_151 =
  fun _1 ->
    (
# 434 "src/lang/parser.mly"
                     ( _1, None )
# 2994 "src/lang/parser.ml"
     : (Parser_helper.meth_pattern_el))

let _menhir_action_152 =
  fun _1 _3 ->
    (
# 435 "src/lang/parser.mly"
                     ( _1, Some _3 )
# 3002 "src/lang/parser.ml"
     : (Parser_helper.meth_pattern_el))

let _menhir_action_153 =
  fun () ->
    (
# 438 "src/lang/parser.mly"
                                            ( [] )
# 3010 "src/lang/parser.ml"
     : (Parser_helper.meth_pattern_el list))

let _menhir_action_154 =
  fun _1 ->
    (
# 439 "src/lang/parser.mly"
                                            ( [_1] )
# 3018 "src/lang/parser.ml"
     : (Parser_helper.meth_pattern_el list))

let _menhir_action_155 =
  fun _1 _3 ->
    (
# 440 "src/lang/parser.mly"
                                            ( _1::_3 )
# 3026 "src/lang/parser.ml"
     : (Parser_helper.meth_pattern_el list))

let _menhir_action_156 =
  fun () ->
    (
# 446 "src/lang/parser.mly"
                                           ( Some (PVar ["_"]), [] )
# 3034 "src/lang/parser.ml"
     : (Term.pattern option * Parser_helper.meth_pattern_el list))

let _menhir_action_157 =
  fun _2 ->
    (
# 447 "src/lang/parser.mly"
                                           ( Some (PVar [_2]), [] )
# 3042 "src/lang/parser.ml"
     : (Term.pattern option * Parser_helper.meth_pattern_el list))

let _menhir_action_158 =
  fun _1 _3 ->
    (
# 448 "src/lang/parser.mly"
                                           ( fst _3, _1::(snd _3) )
# 3050 "src/lang/parser.ml"
     : (Term.pattern option * Parser_helper.meth_pattern_el list))

let _menhir_action_159 =
  fun _1 _3 ->
    (
# 317 "src/lang/parser.mly"
                            ( {meth_ty_name = _1; meth_ty_typ = _3; meth_ty_optional = false; meth_ty_json_name = None } )
# 3058 "src/lang/parser.ml"
     : (Parser_helper.meth_ty_opt))

let _menhir_action_160 =
  fun _1 _4 ->
    (
# 318 "src/lang/parser.mly"
                            ( {meth_ty_name = _1; meth_ty_typ = _4; meth_ty_optional = true; meth_ty_json_name = None } )
# 3066 "src/lang/parser.ml"
     : (Parser_helper.meth_ty_opt))

let _menhir_action_161 =
  fun _1 _2 _3 _5 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 319 "src/lang/parser.mly"
                            (
       match _2 with
         |"as" ->             {meth_ty_name = _3; meth_ty_typ = _5; meth_ty_optional = false; meth_ty_json_name = Some _1}
         | _ -> raise (Parse_error (_loc, "Invalid type constructor")) )
# 3080 "src/lang/parser.ml"
     : (Parser_helper.meth_ty_opt))

let _menhir_action_162 =
  fun _1 _2 _3 _6 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 323 "src/lang/parser.mly"
                                     (
       match _2 with
         |"as" ->             {meth_ty_name =_3; meth_ty_typ = _6; meth_ty_optional = true; meth_ty_json_name = Some _1}
         | _ -> raise (Parse_error (_loc, "Invalid type constructor")) )
# 3094 "src/lang/parser.ml"
     : (Parser_helper.meth_ty_opt))

let _menhir_action_163 =
  fun _2 ->
    (
# 529 "src/lang/parser.mly"
              ( Some _2 )
# 3102 "src/lang/parser.ml"
     : (Term.term option))

let _menhir_action_164 =
  fun () ->
    (
# 530 "src/lang/parser.mly"
              ( None )
# 3110 "src/lang/parser.ml"
     : (Term.term option))

let _menhir_action_165 =
  fun _1 ->
    (
# 408 "src/lang/parser.mly"
               ( _1 )
# 3118 "src/lang/parser.ml"
     : (string))

let _menhir_action_166 =
  fun () ->
    (
# 409 "src/lang/parser.mly"
               ( "_" )
# 3126 "src/lang/parser.ml"
     : (string))

let _menhir_action_167 =
  fun _1 ->
    (
# 465 "src/lang/parser.mly"
                  ( _1 )
# 3134 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_168 =
  fun _1 ->
    (
# 466 "src/lang/parser.mly"
                  ( _1 )
# 3142 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_169 =
  fun _1 ->
    (
# 467 "src/lang/parser.mly"
                  ( _1 )
# 3150 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_170 =
  fun _1 ->
    (
# 468 "src/lang/parser.mly"
                  ( _1 )
# 3158 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_171 =
  fun () ->
    (
# 412 "src/lang/parser.mly"
                               ( [] )
# 3166 "src/lang/parser.ml"
     : (Term.pattern list))

let _menhir_action_172 =
  fun _1 ->
    (
# 413 "src/lang/parser.mly"
                               ( [_1] )
# 3174 "src/lang/parser.ml"
     : (Term.pattern list))

let _menhir_action_173 =
  fun _1 _3 ->
    (
# 414 "src/lang/parser.mly"
                               ( _1@[_3] )
# 3182 "src/lang/parser.ml"
     : (Term.pattern list))

let _menhir_action_174 =
  fun _1 ->
    (
# 421 "src/lang/parser.mly"
                                                 ( [], Some _1, [] )
# 3190 "src/lang/parser.ml"
     : (Term.pattern list * string option * Term.pattern list))

let _menhir_action_175 =
  fun _1 ->
    (
# 422 "src/lang/parser.mly"
                                                 ( [], None,    _1 )
# 3198 "src/lang/parser.ml"
     : (Term.pattern list * string option * Term.pattern list))

let _menhir_action_176 =
  fun _1 _3 ->
    (
# 423 "src/lang/parser.mly"
                                                 ( [], Some _1, _3 )
# 3206 "src/lang/parser.ml"
     : (Term.pattern list * string option * Term.pattern list))

let _menhir_action_177 =
  fun _1 _3 ->
    (
# 424 "src/lang/parser.mly"
                                                 ( _1, Some _3, [] )
# 3214 "src/lang/parser.ml"
     : (Term.pattern list * string option * Term.pattern list))

let _menhir_action_178 =
  fun _1 _3 _5 ->
    (
# 425 "src/lang/parser.mly"
                                                 ( _1, Some _3, _5 )
# 3222 "src/lang/parser.ml"
     : (Term.pattern list * string option * Term.pattern list))

let _menhir_action_179 =
  fun _2 ->
    (
# 568 "src/lang/parser.mly"
                             ( _2 )
# 3230 "src/lang/parser.ml"
     : (Parser_helper.encoder_opt))

let _menhir_action_180 =
  fun _endpos__1_ _startpos__1_ ->
    let _ = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 180 "src/lang/parser.mly"
          ( raise (Parse_error (_loc, "Syntax error!")) )
# 3241 "src/lang/parser.ml"
     : (Term.term)) in
    prerr_string "Menhir: misuse: the semantic action associated with the production\nprogram -> error\nis expected to abort the parser, but does not do so.\n";
    assert false

let _menhir_action_181 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 181 "src/lang/parser.mly"
        ( mk ~pos:_loc unit )
# 3254 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_182 =
  fun _1 ->
    (
# 182 "src/lang/parser.mly"
              ( _1 )
# 3262 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_183 =
  fun _1 _3 ->
    (
# 571 "src/lang/parser.mly"
                  (
      fun ~pos:_ e -> Term.make ~t:e.Term.t ~methods:(Methods.add _1 _3 e.methods) e.Term.term
  )
# 3272 "src/lang/parser.ml"
     : (Parser_helper.record))

let _menhir_action_184 =
  fun _1 _3 _5 ->
    (
# 574 "src/lang/parser.mly"
                               (
      fun ~pos e ->
        let tm = _1 ~pos e in
        Term.make ~t:tm.Term.t ~methods:(Methods.add _3 _5 tm.methods) tm.Term.term
  )
# 3284 "src/lang/parser.ml"
     : (Parser_helper.record))

let _menhir_action_185 =
  fun _2 ->
    (
# 443 "src/lang/parser.mly"
                                ( _2 )
# 3292 "src/lang/parser.ml"
     : (Parser_helper.meth_pattern_el list))

let _menhir_action_186 =
  fun _2 ->
    (
# 451 "src/lang/parser.mly"
                               ( _2 )
# 3300 "src/lang/parser.ml"
     : (Term.pattern option * Parser_helper.meth_pattern_el list))

let _menhir_action_187 =
  fun _endpos__0_ ->
    let _endpos = _endpos__0_ in
    let _startpos = _endpos__0_ in
    let _loc = (_startpos, _endpos) in
    (
# 310 "src/lang/parser.mly"
                            ( Type.make ~pos:_loc (Type.Tuple []) )
# 3311 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_188 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 311 "src/lang/parser.mly"
                            ( let {meth_ty_name = name; meth_ty_typ = ty; meth_ty_optional = optional; meth_ty_json_name = json_name} = _1 in
                              Type.meth ~pos:_loc ?json_name ~optional name ([], ty) (Type.make ~pos:_loc (Type.Tuple [])) )
# 3323 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_189 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 313 "src/lang/parser.mly"
                            ( let {meth_ty_name = name; meth_ty_typ = ty; meth_ty_optional = optional; meth_ty_json_name = json_name} = _1 in
                              Type.meth ~pos:_loc ?json_name ~optional name ([], ty) _3 )
# 3335 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_190 =
  fun () ->
    (
# 189 "src/lang/parser.mly"
     ()
# 3343 "src/lang/parser.ml"
     : (unit))

let _menhir_action_191 =
  fun () ->
    (
# 189 "src/lang/parser.mly"
               ()
# 3351 "src/lang/parser.ml"
     : (unit))

let _menhir_action_192 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 202 "src/lang/parser.mly"
                             ( mk ~pos:_loc (Open (_2,_4)) )
# 3362 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_193 =
  fun _1 ->
    (
# 203 "src/lang/parser.mly"
                             ( _1 )
# 3370 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_194 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 204 "src/lang/parser.mly"
                             ( mk ~pos:_loc (Seq (_1,_3)) )
# 3381 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_195 =
  fun _1 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 205 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 (mk ~pos:_loc unit) )
# 3393 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_196 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 206 "src/lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 _3 )
# 3402 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_197 =
  fun () ->
    (
# 417 "src/lang/parser.mly"
                     ( "_" )
# 3410 "src/lang/parser.ml"
     : (string))

let _menhir_action_198 =
  fun _2 ->
    (
# 418 "src/lang/parser.mly"
                     ( _2 )
# 3418 "src/lang/parser.ml"
     : (string))

let _menhir_action_199 =
  fun _1 _3 ->
    (
# 471 "src/lang/parser.mly"
                        ( _1::_3 )
# 3426 "src/lang/parser.ml"
     : (string list))

let _menhir_action_200 =
  fun _1 _3 ->
    (
# 537 "src/lang/parser.mly"
                             ( _1::_3 )
# 3434 "src/lang/parser.ml"
     : (string list))

let _menhir_action_201 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 293 "src/lang/parser.mly"
             ( mk_time_pred ~pos:_loc (between ~pos:_loc (fst _1) (snd _1)) )
# 3445 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_202 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 294 "src/lang/parser.mly"
             ( mk_time_pred ~pos:_loc (during ~pos:_loc _1) )
# 3456 "src/lang/parser.ml"
     : (Term.term))

let _menhir_action_203 =
  fun _2 ->
    (
# 428 "src/lang/parser.mly"
                                       ( PTuple _2 )
# 3464 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_204 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 297 "src/lang/parser.mly"
                                 ( Type.var ~pos:_loc () )
# 3475 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_205 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 298 "src/lang/parser.mly"
                                 ( mk_ty ~pos:_loc _1 )
# 3486 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_206 =
  fun _1 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 299 "src/lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.Nullable _1) )
# 3497 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_207 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 300 "src/lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.(List {t = _2; json_repr = `Tuple})) )
# 3508 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_208 =
  fun _2 _4 _5 _7 _endpos__7_ _startpos__1_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 301 "src/lang/parser.mly"
                                 ( mk_json_assoc_object_ty ~pos:_loc (_2,_4,_5,_7) )
# 3519 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_209 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 302 "src/lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.Tuple _2) )
# 3530 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_210 =
  fun _2 _5 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 303 "src/lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.Arrow (_2,_5)) )
# 3541 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_211 =
  fun _2 ->
    (
# 304 "src/lang/parser.mly"
                                 ( _2 )
# 3549 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_212 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 305 "src/lang/parser.mly"
                                 ( mk_invoke_ty ~pos:_loc _1 _3 )
# 3560 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_213 =
  fun _1 _4 ->
    (
# 306 "src/lang/parser.mly"
                                 ( Type.remeth _4 _1 )
# 3568 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_214 =
  fun _1 ->
    (
# 307 "src/lang/parser.mly"
                                 ( _1 )
# 3576 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_215 =
  fun _1 ->
    (
# 338 "src/lang/parser.mly"
                                  ( _1, [] )
# 3584 "src/lang/parser.ml"
     : (Parser_helper.ty_content))

let _menhir_action_216 =
  fun _1 _3 ->
    (
# 339 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3, [] )
# 3592 "src/lang/parser.ml"
     : (Parser_helper.ty_content))

let _menhir_action_217 =
  fun _1 _3 _5 ->
    (
# 340 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3 ^ "." ^ _5, [] )
# 3600 "src/lang/parser.ml"
     : (Parser_helper.ty_content))

let _menhir_action_218 =
  fun _1 _2 ->
    (
# 341 "src/lang/parser.mly"
                                  ( _1, _2 )
# 3608 "src/lang/parser.ml"
     : (Parser_helper.ty_content))

let _menhir_action_219 =
  fun _1 _3 _4 ->
    (
# 343 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3, _4 )
# 3616 "src/lang/parser.ml"
     : (Parser_helper.ty_content))

let _menhir_action_220 =
  fun _1 _3 _5 _6 ->
    (
# 345 "src/lang/parser.mly"
                                  ( _1 ^ "." ^ _3 ^ "." ^ _5, _6 )
# 3624 "src/lang/parser.ml"
     : (Parser_helper.ty_content))

let _menhir_action_221 =
  fun _1 ->
    (
# 354 "src/lang/parser.mly"
                         ( "",_1 )
# 3632 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_222 =
  fun _1 ->
    (
# 355 "src/lang/parser.mly"
                         ( "", string_of_int _1 )
# 3640 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_223 =
  fun _1 ->
    (
# 356 "src/lang/parser.mly"
                         ( "", string_of_float _1 )
# 3648 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_224 =
  fun _1 ->
    (
# 357 "src/lang/parser.mly"
                         ( "",_1 )
# 3656 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_225 =
  fun _1 _3 ->
    (
# 358 "src/lang/parser.mly"
                         ( _1,_3 )
# 3664 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_226 =
  fun _1 _3 ->
    (
# 359 "src/lang/parser.mly"
                         ( _1,_3)
# 3672 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_227 =
  fun _1 _3 ->
    (
# 360 "src/lang/parser.mly"
                         ( _1,string_of_int _3)
# 3680 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_228 =
  fun _1 _3 ->
    (
# 361 "src/lang/parser.mly"
                         ( _1,string_of_float _3)
# 3688 "src/lang/parser.ml"
     : (Parser_helper.ty_content_arg))

let _menhir_action_229 =
  fun () ->
    (
# 349 "src/lang/parser.mly"
                                         ( [] )
# 3696 "src/lang/parser.ml"
     : (Parser_helper.ty_content_args))

let _menhir_action_230 =
  fun _1 ->
    (
# 350 "src/lang/parser.mly"
                                         ( [_1] )
# 3704 "src/lang/parser.ml"
     : (Parser_helper.ty_content_args))

let _menhir_action_231 =
  fun _1 _3 ->
    (
# 351 "src/lang/parser.mly"
                                         ( _1::_3 )
# 3712 "src/lang/parser.ml"
     : (Parser_helper.ty_content_args))

let _menhir_action_232 =
  fun _1 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 329 "src/lang/parser.mly"
                                  ( mk_source_ty ~pos:_loc ~extensible:false _1 [] )
# 3723 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_233 =
  fun _1 _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 330 "src/lang/parser.mly"
                                  ( mk_source_ty ~pos:_loc ~extensible:(fst _2) _1 (snd _2) )
# 3734 "src/lang/parser.ml"
     : (Type_base.t))

let _menhir_action_234 =
  fun _1 _3 ->
    (
# 333 "src/lang/parser.mly"
                        ( false, [_1,_3] )
# 3742 "src/lang/parser.ml"
     : (bool * (string * Parser_helper.ty_content) list))

let _menhir_action_235 =
  fun () ->
    (
# 334 "src/lang/parser.mly"
              ( true, [] )
# 3750 "src/lang/parser.ml"
     : (bool * (string * Parser_helper.ty_content) list))

let _menhir_action_236 =
  fun _1 _3 _5 ->
    (
# 335 "src/lang/parser.mly"
                                               ( fst _5, ((_1,_3)::(snd _5)) )
# 3758 "src/lang/parser.ml"
     : (bool * (string * Parser_helper.ty_content) list))

let _menhir_action_237 =
  fun _1 _3 ->
    (
# 364 "src/lang/parser.mly"
                ( [_1; _3] )
# 3766 "src/lang/parser.ml"
     : (Type_base.t list))

let _menhir_action_238 =
  fun _1 _3 ->
    (
# 365 "src/lang/parser.mly"
                      ( _1::_3 )
# 3774 "src/lang/parser.ml"
     : (Type_base.t list))

let _menhir_action_239 =
  fun _1 ->
    (
# 462 "src/lang/parser.mly"
           ( PVar [_1] )
# 3782 "src/lang/parser.ml"
     : (Term.pattern))

let _menhir_action_240 =
  fun _2 ->
    (
# 378 "src/lang/parser.mly"
                         ( _2 )
# 3790 "src/lang/parser.ml"
     : (Parser_helper.inner_list))

let _menhir_action_241 =
  fun _1 ->
    (
# 509 "src/lang/parser.mly"
                    ( [_1] )
# 3798 "src/lang/parser.ml"
     : (string list))

let _menhir_action_242 =
  fun _1 _3 ->
    (
# 510 "src/lang/parser.mly"
                    ( _1::_3 )
# 3806 "src/lang/parser.ml"
     : (string list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ARGS_OF ->
        "ARGS_OF"
    | BEGIN ->
        "BEGIN"
    | BIN1 _ ->
        "BIN1"
    | BIN2 _ ->
        "BIN2"
    | BIN3 _ ->
        "BIN3"
    | BINB _ ->
        "BINB"
    | BOOL _ ->
        "BOOL"
    | CATCH ->
        "CATCH"
    | COALESCE ->
        "COALESCE"
    | COLON ->
        "COLON"
    | COLONCOLON ->
        "COLONCOLON"
    | COMMA ->
        "COMMA"
    | DEF _ ->
        "DEF"
    | DO ->
        "DO"
    | DOT ->
        "DOT"
    | DOTDOTDOT ->
        "DOTDOTDOT"
    | DOTVAR _ ->
        "DOTVAR"
    | ELSE ->
        "ELSE"
    | ELSIF ->
        "ELSIF"
    | ENCODER _ ->
        "ENCODER"
    | END ->
        "END"
    | EOF ->
        "EOF"
    | FLOAT _ ->
        "FLOAT"
    | FOR ->
        "FOR"
    | FUN ->
        "FUN"
    | GET ->
        "GET"
    | GETS ->
        "GETS"
    | IF ->
        "IF"
    | INT _ ->
        "INT"
    | INTERVAL _ ->
        "INTERVAL"
    | LBRA ->
        "LBRA"
    | LCUR ->
        "LCUR"
    | LET _ ->
        "LET"
    | LETLBRA _ ->
        "LETLBRA"
    | LPAR ->
        "LPAR"
    | MINUS ->
        "MINUS"
    | NOT ->
        "NOT"
    | OPEN ->
        "OPEN"
    | PP_COMMENT _ ->
        "PP_COMMENT"
    | PP_DEF _ ->
        "PP_DEF"
    | PP_DEFINE ->
        "PP_DEFINE"
    | PP_ELSE ->
        "PP_ELSE"
    | PP_ENDIF ->
        "PP_ENDIF"
    | PP_ENDL ->
        "PP_ENDL"
    | PP_IFDEF _ ->
        "PP_IFDEF"
    | PP_IFENCODER ->
        "PP_IFENCODER"
    | PP_IFNDEF _ ->
        "PP_IFNDEF"
    | PP_IFNENCODER ->
        "PP_IFNENCODER"
    | PP_IFVERSION _ ->
        "PP_IFVERSION"
    | PP_INCLUDE _ ->
        "PP_INCLUDE"
    | PP_INCLUDE_EXTRA _ ->
        "PP_INCLUDE_EXTRA"
    | PP_INT_DOT_LCUR _ ->
        "PP_INT_DOT_LCUR"
    | PP_REGEXP _ ->
        "PP_REGEXP"
    | PP_STRING _ ->
        "PP_STRING"
    | QUESTION ->
        "QUESTION"
    | QUESTION_DOT ->
        "QUESTION_DOT"
    | RBRA ->
        "RBRA"
    | RCUR ->
        "RCUR"
    | REGEXP _ ->
        "REGEXP"
    | REPLACES ->
        "REPLACES"
    | RPAR ->
        "RPAR"
    | SEQ ->
        "SEQ"
    | SEQSEQ ->
        "SEQSEQ"
    | SET ->
        "SET"
    | SLASH ->
        "SLASH"
    | STRING _ ->
        "STRING"
    | THEN ->
        "THEN"
    | TILD ->
        "TILD"
    | TIME _ ->
        "TIME"
    | TIMES ->
        "TIMES"
    | TO ->
        "TO"
    | TRY ->
        "TRY"
    | UMINUS ->
        "UMINUS"
    | UNDERSCORE ->
        "UNDERSCORE"
    | VAR _ ->
        "VAR"
    | VARLBRA _ ->
        "VARLBRA"
    | VARLPAR _ ->
        "VARLPAR"
    | WHILE ->
        "WHILE"
    | YIELDS ->
        "YIELDS"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_018 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _v ->
      MenhirBox_annotate_metadata_entry _v
  
  let _menhir_run_014 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annotate =
    fun _menhir_stack _v ->
      let _1 = _v in
      let _v = _menhir_action_008 _1 in
      MenhirBox_annotate _v
  
  let rec _menhir_goto_annotate_metadata : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _menhir_box_annotate =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState000 ->
          _menhir_run_014 _menhir_stack _v
      | MenhirState003 ->
          _menhir_run_004 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_004 : type  ttv_stack. (ttv_stack, _menhir_box_annotate) _menhir_cell1_annotate_metadata_entry -> _ -> _menhir_box_annotate =
    fun _menhir_stack _v ->
      let MenhirCell1_annotate_metadata_entry (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_011 _1 _2 in
      _menhir_goto_annotate_metadata _menhir_stack _v _menhir_s
  
  let rec _menhir_run_001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_009 _1 in
      _menhir_goto_annotate_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annotate_key : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState017 ->
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState003 ->
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_019 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate_metadata_entry) _menhir_state -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState020 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_007 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_017 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_annotate_value : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState020 ->
          _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState006 ->
          _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_021 : type  ttv_stack. (ttv_stack, _menhir_box_annotate_metadata_entry) _menhir_cell1_annotate_key -> _ -> _ -> _ -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_013 _1 _3 in
          _menhir_goto_annotate_metadata_entry _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_annotate_metadata_entry : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState017 ->
          _menhir_run_018 _menhir_stack _v
      | MenhirState003 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_metadata_entry (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState003
      | STRING _v_1 ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState003
      | _ ->
          _eRR ()
  
  and _menhir_run_002 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_010 _1 in
      _menhir_goto_annotate_key _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_012 : type  ttv_stack. (ttv_stack, _menhir_box_annotate) _menhir_cell1_annotate_key -> _ -> _ -> _ -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_013 _1 _3 in
          _menhir_goto_annotate_metadata_entry _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COLON ->
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_012 _1 _3 in
          _menhir_goto_annotate_metadata _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_008 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_018 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_009 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_014 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_010 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_015 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_011 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_annotate_key as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_016 _1 in
      _menhir_goto_annotate_value _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_005 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState006 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_007 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_008 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_009 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT _v ->
              _menhir_run_010 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_011 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState000 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_017 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState017 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_001 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_002 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_515 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_time_predicate =
    fun _menhir_stack _v ->
      MenhirBox_time_predicate _v
  
  let _menhir_run_503 : type  ttv_stack. ttv_stack _menhir_cell0_LPAR -> _ -> _menhir_box_plain_encoder_params =
    fun _menhir_stack _v ->
      let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_179 _2 in
      MenhirBox_plain_encoder_params _v
  
  let _menhir_goto_program : type  ttv_stack. ttv_stack -> _ -> _menhir_box_program =
    fun _menhir_stack _v ->
      MenhirBox_program _v
  
  let _menhir_run_510 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_182 _1 in
          _menhir_goto_program _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_goto_interactive : type  ttv_stack. ttv_stack -> _ -> _menhir_box_interactive =
    fun _menhir_stack _v ->
      MenhirBox_interactive _v
  
  let _menhir_run_499 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | SEQSEQ ->
          let _1 = _v in
          let _v = _menhir_action_136 _1 in
          _menhir_goto_interactive _menhir_stack _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_025 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_WHILE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState025 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState026
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState026
      | VAR _v_2 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState026
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState026
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState026
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState026
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | INTERVAL _v_6 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState026
      | INT _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState026
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FLOAT _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState026
      | ENCODER _v_9 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState026
      | BOOL _v_10 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState026
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | ARGS_OF ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | RPAR ->
          let _v_11 = _menhir_action_019 () in
          _menhir_run_491 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState027 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_028 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_expr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState025 ->
          _menhir_run_493 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState027 ->
          _menhir_run_489 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState036 ->
          _menhir_run_474 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState037 ->
          _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState467 ->
          _menhir_run_469 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_465 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState040 ->
          _menhir_run_457 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState454 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState446 ->
          _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState442 ->
          _menhir_run_443 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_440 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState432 ->
          _menhir_run_433 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_413 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState411 ->
          _menhir_run_412 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState058 ->
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_396 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_387 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_384 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState341 ->
          _menhir_run_342 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState338 ->
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState335 ->
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState506 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState480 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState475 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState461 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState458 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState444 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState421 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState423 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState425 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState427 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState375 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState323 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState312 ->
          _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_304 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState243 ->
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState268 ->
          _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState266 ->
          _menhir_run_267 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState264 ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState262 ->
          _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_261 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState258 ->
          _menhir_run_259 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState256 ->
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState254 ->
          _menhir_run_255 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState252 ->
          _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState247 ->
          _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState240 ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState238 ->
          _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState236 ->
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_493 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WHILE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | TIMES ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | SET ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | QUESTION_DOT ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | QUESTION ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | MINUS ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | DOT ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | DO ->
          let _menhir_stack = MenhirCell1_DO (_menhir_stack, MenhirState493) in
          let _menhir_s = MenhirState494 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLONCOLON ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | COALESCE ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState493
      | BINB _v_14 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState493
      | BIN3 _v_15 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState493
      | BIN2 _v_16 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState493
      | BIN1 _v_17 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState493
      | _ ->
          _eRR ()
  
  and _menhir_run_238 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TO (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState238 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_029 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_UMINUS (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState029 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState030 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_031 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLONCOLON | DEF _ | DOT | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RCUR | REGEXP _ | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | GETS ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_165 _1 in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_optvar : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState478 ->
          _menhir_run_479 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState052 ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState372 ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState343 ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState344 ->
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState506 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState480 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState475 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState461 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState458 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState444 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState427 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState425 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState423 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState421 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState375 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState323 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState070 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState330 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState080 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState087 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState111 ->
          _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState100 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState089 ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState059 ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_479 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DO ->
          let _menhir_s = MenhirState480 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLON ->
          let _menhir_s = MenhirState483 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_032 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_166 () in
      _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_033 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_202 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_time_predicate _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_time_predicate : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState512 ->
          _menhir_run_515 _menhir_stack _v
      | MenhirState506 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState025 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState027 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState480 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState475 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState036 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState037 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState467 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState461 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState458 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState454 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState040 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState446 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState444 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState442 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState432 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState427 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState425 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState423 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState421 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState411 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState058 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState375 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState341 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState338 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState335 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState323 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState312 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState243 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState268 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState266 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState264 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState262 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState258 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState256 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState254 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState252 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState247 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState240 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState238 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState236 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_234 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_113 _1 in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_034 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_035 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_105 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_036 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState036 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_037 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState037 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_038 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | VARLPAR _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | VARLBRA _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | VAR _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | UMINUS ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | TRY ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | TIME _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | STRING _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_) = (_startpos, _endpos) in
          let _v = _menhir_action_082 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | REGEXP _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | NOT ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | LCUR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | LBRA ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | INTERVAL _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | INT _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | IF ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | GET ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | FUN ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | FOR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | FLOAT _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | ENCODER _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | BOOL _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | BEGIN ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | _ ->
          _eRR ()
  
  and _menhir_run_040 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | VARLPAR _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | VARLBRA _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | VAR _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState040, _v, _startpos_0, _endpos) in
              _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer
          | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | COALESCE | COLONCOLON | DEF _ | DOT | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RCUR | REGEXP _ | SEQ | SET | STRING _ | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
                _menhir_action_077 _1 _endpos__1_ _startpos__1_
              in
              _menhir_run_457 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos_0 _v MenhirState040 _tok
          | _ ->
              _eRR ())
      | UMINUS ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | TRY ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | TIME _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | STRING _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | REGEXP _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_) = (_startpos, _endpos) in
          let _v = _menhir_action_088 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | OPEN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState040 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState442 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | NOT ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | LPAR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | LETLBRA _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | LET _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | LCUR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | LBRA ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | INTERVAL _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | INT _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | IF ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | GET ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | FUN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | FOR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | FLOAT _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | ENCODER _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | DOTDOTDOT ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState040 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState446 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | DEF _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | BOOL _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState040
      | BEGIN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState040
      | _ ->
          _eRR ()
  
  and _menhir_run_042 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState042 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | DOTDOTDOT ->
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | RBRA ->
          let _v = _menhir_action_130 () in
          _menhir_run_438 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_044 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_201 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_time_predicate _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_045 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_046 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState046 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_047 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LETLBRA (_menhir_stack, _menhir_s, _v, _startpos) in
      let _menhir_s = MenhirState047 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_048 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState049 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_142 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_let_opt_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_050 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState050 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_051 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_FUN (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
          | TILD ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
          | LPAR ->
              _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
          | ARGS_OF ->
              _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState052
          | RPAR ->
              let _v = _menhir_action_037 () in
              _menhir_run_409 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState052
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_053 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_165 _1 in
      _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_054 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_TILD (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_stack = MenhirCell1_GETS (_menhir_stack, MenhirState055) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | VARLPAR _v_0 ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState056
              | VARLBRA _v_1 ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState056
              | VAR _v_2 ->
                  _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState056
              | UNDERSCORE ->
                  let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, MenhirState056, _startpos_3, _endpos_4) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | GETS ->
                      _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
                  | COMMA | RPAR ->
                      let _v_5 = _menhir_action_164 () in
                      _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 _tok
                  | _ ->
                      _eRR ())
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | TRY ->
                  _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | TIME _v_6 ->
                  _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState056
              | STRING _v_7 ->
                  _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState056
              | REGEXP _v_8 ->
                  _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState056
              | NOT ->
                  _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | LPAR ->
                  _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | LCUR ->
                  _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | LBRA ->
                  _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | INTERVAL _v_9 ->
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState056
              | INT _v_10 ->
                  _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState056
              | IF ->
                  _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | GET ->
                  _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | FUN ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | FOR ->
                  _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | FLOAT _v_11 ->
                  _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState056
              | ENCODER _v_12 ->
                  _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState056
              | BOOL _v_13 ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState056
              | BEGIN ->
                  _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState056
              | _ ->
                  _eRR ())
          | COMMA | RPAR ->
              let _v_14 = _menhir_action_164 () in
              _menhir_run_402 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 _tok
          | _ ->
              _eRR ())
      | LPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  let _menhir_s = MenhirState405 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v ->
                      _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | VAR _v ->
                      _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | UNDERSCORE ->
                      _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LPAR ->
                      _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LCUR ->
                      _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LBRA ->
                      _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_058 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_GETS (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState058 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_059 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState059 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_062 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_063 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState063
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COLONCOLON | COMMA | DEF _ | DO | DOT | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_052 () in
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_064 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState064
      | STRING _v ->
          _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState064
      | ENCODER _v ->
          _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState064
      | RPAR ->
          let _v = _menhir_action_059 () in
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState066 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_056 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_067 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_068 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_BEGIN (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState068 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_069 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_startpos__1_, _1) = (_startpos, _v) in
      let _v = _menhir_action_006 _1 in
      _menhir_goto__let _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto__let : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1__let (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState325, _v_0, _startpos_1, _endpos) in
              let _menhir_s = MenhirState327 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_328 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | LCUR ->
                  _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | GETS ->
              let _v_3 =
                let _1 = _v_0 in
                _menhir_action_165 _1
              in
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState325 _tok
          | _ ->
              _eRR ())
      | UNDERSCORE ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | LPAR ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState325, _startpos_4) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_5 ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState330
          | UNDERSCORE ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState330
          | LPAR ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState330
          | LCUR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState330
          | LBRA ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState330
          | COMMA | RPAR ->
              let _v_6 = _menhir_action_171 () in
              _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState330 _tok
          | _ ->
              _eRR ())
      | LCUR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | LBRA ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
      | _ ->
          _eRR ()
  
  and _menhir_run_328 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState329 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_328 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | GETS ->
          let _1 = _v in
          let _v = _menhir_action_124 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_in_subfield : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState327 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState285 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState073 ->
          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState329 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState288 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState075 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_131 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_199 _1 _3 in
      _menhir_goto_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_subfield : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState070 ->
          _menhir_run_374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState351 ->
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState325 ->
          _menhir_run_337 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState271 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_374 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_119 () in
          _menhir_run_375 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState374 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_231 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_120 () in
      _menhir_goto_g _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_g : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState378 ->
          _menhir_run_379 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState374 ->
          _menhir_run_375 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState367 ->
          _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState230 ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_379 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState379
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState379
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState379
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState379
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState379
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState379
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | LETLBRA _v_6 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState379
      | LET _v_7 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState379
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | INTERVAL _v_8 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState379
      | INT _v_9 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState379
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | FLOAT _v_10 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState379
      | ENCODER _v_11 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState379
      | DEF _v_12 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState379
      | BOOL _v_13 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState379
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState379
      | _ ->
          _eRR ()
  
  and _menhir_run_070 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_DEF (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v_0 ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState070
      | VAR _v_1 ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState070, _v_1, _startpos_2, _endpos) in
              let _menhir_s = MenhirState073 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v ->
                  _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | LCUR ->
                  _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v_5 =
                let _1 = _v_1 in
                _menhir_action_165 _1
              in
              _menhir_run_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState070 _tok
          | _ ->
              _eRR ())
      | UNDERSCORE ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | LPAR ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, MenhirState070, _startpos_6) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_7 ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState132
          | UNDERSCORE ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | LPAR ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | LCUR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | LBRA ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState132
          | COMMA | RPAR ->
              let _v_8 = _menhir_action_171 () in
              _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState132 _tok
          | _ ->
              _eRR ())
      | LCUR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | LBRA ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState070
      | _ ->
          _eRR ()
  
  and _menhir_run_071 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_241 _1 in
      _menhir_goto_varlpar _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_varlpar : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState070 ->
          _menhir_run_343 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState073 ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState075 ->
          _menhir_run_076 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_343 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_varlpar (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState343
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState343
      | TILD ->
          _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState343
      | LPAR ->
          _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState343
      | ARGS_OF ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState343
      | RPAR ->
          let _v_1 = _menhir_action_037 () in
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState343
      | _ ->
          _eRR ()
  
  and _menhir_run_344 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState344 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_350 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
              let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
              let _menhir_s = MenhirState351 in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_s = MenhirState352 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | GET ->
                  _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | VAR _v ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_startpos__1_, _3, _endpos__4_) = (_startpos, _v, _endpos_4) in
                  let _v = _menhir_action_033 _3 _endpos__4_ _startpos__1_ in
                  _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | DOT ->
                  let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
                  let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
                  let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState351, _v, _startpos_3, _endpos) in
                  _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_273 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState274 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GET ->
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_040 _1 in
          _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_275 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos) in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos_0, _endpos) in
              let _menhir_s = MenhirState277 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | GET ->
                  _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | RBRA ->
              let _2 = _v in
              let _v = _menhir_action_041 _2 in
              _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_args_of_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState358 ->
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState352 ->
          _menhir_run_353 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState291 ->
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState272 ->
          _menhir_run_280 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState274 ->
          _menhir_run_279 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState277 ->
          _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_359 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_subfield_lbra -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_subfield_lbra (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_036 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_arg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_arg (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState372
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
          | TILD ->
              _menhir_run_054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
          | LPAR ->
              _menhir_run_344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
          | ARGS_OF ->
              _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState372
          | RPAR ->
              let _v_1 = _menhir_action_037 () in
              _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_038 _1 in
          _menhir_goto_arglist _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_373 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_arg -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_arg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_039 _1 _3 in
      _menhir_goto_arglist _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_arglist : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState052 ->
          _menhir_run_409 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState372 ->
          _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState343 ->
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_409 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_arglist (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | YIELDS ->
          let _menhir_s = MenhirState411 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_366 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_arglist (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState367
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_119 () in
          _menhir_run_368 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState367 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_368 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState368
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState368
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState368
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState368
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState368
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState368
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | LETLBRA _v_6 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState368
      | LET _v_7 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState368
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | INTERVAL _v_8 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState368
      | INT _v_9 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState368
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | FLOAT _v_10 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState368
      | ENCODER _v_11 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState368
      | DEF _v_12 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState368
      | BOOL _v_13 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState368
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState368
      | _ ->
          _eRR ()
  
  and _menhir_run_353 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_035 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_292 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_subfield_lbra -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_subfield_lbra (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_027 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_app_list_elem : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_app_list_elem (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState299
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState299
          | VAR _v_2 ->
              _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState299
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | TIME _v_3 ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState299
          | STRING _v_4 ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState299
          | REGEXP _v_5 ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState299
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | INTERVAL _v_6 ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState299
          | INT _v_7 ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState299
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | FLOAT _v_8 ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState299
          | ENCODER _v_9 ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState299
          | BOOL _v_10 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState299
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | ARGS_OF ->
              _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState299
          | RPAR ->
              let _v_11 = _menhir_action_019 () in
              _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_020 _1 in
          _menhir_goto_app_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_244 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState245 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | COALESCE | COLONCOLON | COMMA | DOT | MINUS | QUESTION | QUESTION_DOT | RPAR | SET | TIMES | TO ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_270 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
              let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
              let _menhir_s = MenhirState271 in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _menhir_s = MenhirState272 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | GET ->
                  _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | VAR _v ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_startpos__1_, _3, _endpos__4_) = (_startpos, _v, _endpos_4) in
                  let _v = _menhir_action_024 _3 _endpos__4_ _startpos__1_ in
                  _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | DOT ->
                  let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
                  let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
                  let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState271, _v, _startpos_3, _endpos) in
                  _menhir_run_285 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_285 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState285 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLBRA _v ->
          _menhir_run_286 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_287 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_286 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_126 _1 in
      _menhir_goto_in_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_in_subfield_lbra : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState285 ->
          _menhir_run_290 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState288 ->
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_290 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_200 _1 _3 in
      _menhir_goto_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_subfield_lbra : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState351 ->
          _menhir_run_358 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState271 ->
          _menhir_run_291 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_358 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield_lbra (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState358
      | GET ->
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState358
      | _ ->
          _eRR ()
  
  and _menhir_run_291 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield_lbra (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState291
      | GET ->
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
      | _ ->
          _eRR ()
  
  and _menhir_run_289 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_127 _1 _3 in
      _menhir_goto_in_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_287 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState288 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              _menhir_run_286 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_287 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_124 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_300 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_app_list_elem -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_app_list_elem (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_021 _1 _3 in
      _menhir_goto_app_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_app_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState026 ->
          _menhir_run_491 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState243 ->
          _menhir_run_301 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState299 ->
          _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_491 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_091 _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_301 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_139 _1 _2 in
      _menhir_goto_invoke _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_goto_invoke : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState242 ->
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState249 ->
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_314 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_090 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_251 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION_DOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_QUESTION_DOT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_089 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_280 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_026 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_279 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_042 _1 _3 in
      _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_278 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GET _menhir_cell0_VAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
      let MenhirCell1_GET (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_043 _2 _4 in
      _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_076 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_242 _1 _3 in
      _menhir_goto_varlpar _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_074 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState075 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_074 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _1 = _v in
          let _v = _menhir_action_124 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState078
      | RCUR ->
          let _v = _menhir_action_153 () in
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_079 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState080 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_151 _1 in
          _menhir_goto_meth_pattern_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_081 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState082 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLON | COMMA | RBRA | RCUR | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_165 _1 in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_084 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _menhir_s = MenhirState085 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | BEGIN | BOOL _ | COLON | COMMA | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_166 () in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_087 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState087
      | UNDERSCORE ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState087
      | LPAR ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState087
      | LCUR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState087
      | LBRA ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState087
      | COMMA | RPAR ->
          let _v = _menhir_action_171 () in
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState087 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_088 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState088
      | DOTDOTDOT ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState088
      | RCUR ->
          let _v = _menhir_action_153 () in
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState089
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
      | RCUR ->
          let _v = _menhir_action_156 () in
          _menhir_goto_meth_spread_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_meth_spread_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState096 ->
          _menhir_run_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState088 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_097 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_pattern_el -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_158 _1 _3 in
      _menhir_goto_meth_spread_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_091 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_186 _2 in
          let _1 = _v in
          let _v = _menhir_action_145 _1 in
          _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_meth_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_170 _1 in
      _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState070 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_340 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState330 ->
          _menhir_run_331 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_133 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState080 ->
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState087 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState111 ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_378 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState378
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_119 () in
          _menhir_run_379 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState378 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_340 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState341 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_331 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState332 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_172 _1 in
          _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_135 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState135
      | RPAR ->
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1, _endpos__2_) = (_startpos, _v, _endpos_1) in
          let _v = _menhir_action_232 _1 _endpos__2_ _startpos__1_ in
          _menhir_goto_ty_source _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | DOTDOTDOT ->
          let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState135
      | _ ->
          _eRR ()
  
  and _menhir_run_136 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_0, _startpos_1, _endpos_2) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v_3 ->
                  _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState138
              | STRING _v_4 ->
                  _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState138
              | INT _v_5 ->
                  _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState138
              | FLOAT _v_6 ->
                  _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState138
              | RPAR ->
                  let _v_7 = _menhir_action_229 () in
                  _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7
              | _ ->
                  _eRR ())
          | VAR _v_8 ->
              let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | DOT ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v_11 ->
                      let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_8, _startpos_9, _endpos_10) in
                      let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_11, _startpos_12, _endpos_13) in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VAR _v_14 ->
                          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState155
                      | STRING _v_15 ->
                          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState155
                      | INT _v_16 ->
                          _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState155
                      | FLOAT _v_17 ->
                          _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState155
                      | RPAR ->
                          let _v_18 = _menhir_action_229 () in
                          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18
                      | _ ->
                          _eRR ())
                  | VAR _v_19 ->
                      let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | DOT ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | VARLPAR _v_22 ->
                              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_8, _startpos_9, _endpos_10) in
                              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_19, _startpos_20, _endpos_21) in
                              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
                              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
                              let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_22, _startpos_23, _endpos_24) in
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | VAR _v_25 ->
                                  _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v_25 MenhirState160
                              | STRING _v_26 ->
                                  _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v_26 MenhirState160
                              | INT _v_27 ->
                                  _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState160
                              | FLOAT _v_28 ->
                                  _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v_28 MenhirState160
                              | RPAR ->
                                  let _v_29 = _menhir_action_229 () in
                                  _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v_29
                              | _ ->
                                  _eRR ())
                          | VAR _v_30 ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              let (_1, _3, _5) = (_v_8, _v_19, _v_30) in
                              let _v = _menhir_action_217 _1 _3 _5 in
                              _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
                          | _ ->
                              _eRR ())
                      | COMMA | RPAR ->
                          let (_1, _3) = (_v_8, _v_19) in
                          let _v = _menhir_action_216 _1 _3 in
                          _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | COMMA | RPAR ->
                  let _1 = _v_8 in
                  let _v = _menhir_action_215 _1 in
                  _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_139 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_0) in
              let _v = _menhir_action_225 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | STRING _v_3 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_3) in
              let _v = _menhir_action_226 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | INT _v_6 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_6) in
              let _v = _menhir_action_227 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | FLOAT _v_9 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_9) in
              let _v = _menhir_action_228 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_221 _1 in
          _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_content_arg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_ty_content_arg (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState151
          | STRING _v_1 ->
              _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState151
          | INT _v_2 ->
              _menhir_run_146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState151
          | FLOAT _v_3 ->
              _menhir_run_147 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState151
          | RPAR ->
              let _v_4 = _menhir_action_229 () in
              _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_230 _1 in
          _menhir_goto_ty_content_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_145 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_224 _1 in
      _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_146 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_222 _1 in
      _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_147 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_223 _1 in
      _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_152 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty_content_arg -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_ty_content_arg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_231 _1 _3 in
      _menhir_goto_ty_content_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_ty_content_args : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState160 ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState155 ->
          _menhir_run_156 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState151 ->
          _menhir_run_152 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState138 ->
          _menhir_run_148 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_161 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _5, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_220 _1 _3 _5 _6 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_ty_content : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell0_ty_content (_menhir_stack, _v) in
          let _menhir_s = MenhirState165 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DOTDOTDOT ->
              _menhir_run_166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_234 _1 _3 in
          _menhir_goto_ty_source_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_166 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _v = _menhir_action_235 () in
      _menhir_goto_ty_source_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ty_source_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState135 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState165 ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_169 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_233 _1 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_ty_source _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_source : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_214 _1 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState470 ->
          _menhir_run_471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState405 ->
          _menhir_run_406 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState346 ->
          _menhir_run_347 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState332 ->
          _menhir_run_333 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState134 ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState227 ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState222 ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState218 ->
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState173 ->
          _menhir_run_217 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState213 ->
          _menhir_run_214 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState175 ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState206 ->
          _menhir_run_207 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState179 ->
          _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState198 ->
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState196 ->
          _menhir_run_197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState180 ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_471 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_069 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_188 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let _endpos__2_ = _endpos in
      let _v = _menhir_action_206 _1 _endpos__2_ _startpos__1_ in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_189 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_212 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | LCUR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_LCUR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState191
          | STRING _v ->
              _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState191
          | RCUR ->
              let _v =
                let _endpos__0_ = _endpos in
                _menhir_action_187 _endpos__0_
              in
              _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_177 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_QUESTION (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _menhir_s = MenhirState179 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v ->
                  _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UNDERSCORE ->
                  _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | COLON ->
          let _menhir_s = MenhirState206 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_171 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_205 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_172 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_204 _endpos__1_ _startpos__1_ in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_173 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState173
      | VAR _v ->
          _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState173
      | UNDERSCORE ->
          _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState173
      | QUESTION ->
          _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState173
      | LPAR ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState173
      | LCUR ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState173
      | LBRA ->
          _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState173
      | RPAR ->
          let _v = _menhir_action_044 () in
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState173
      | _ ->
          _eRR ()
  
  and _menhir_run_174 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState175 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | DOT | QUESTION | RPAR | TIMES ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_205 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_176 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState176
      | STRING _v ->
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState176
      | RCUR ->
          let _v =
            let _endpos__0_ = _endpos in
            _menhir_action_187 _endpos__0_
          in
          _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_192 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_STRING (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | QUESTION ->
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _menhir_stack = MenhirCell0_QUESTION (_menhir_stack, _endpos) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | COLON ->
                      let _menhir_s = MenhirState196 in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VARLPAR _v ->
                          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                      | VAR _v ->
                          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                      | UNDERSCORE ->
                          _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | LPAR ->
                          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | LCUR ->
                          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | LBRA ->
                          _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | COLON ->
                  let _menhir_s = MenhirState198 in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v ->
                      _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | VAR _v ->
                      _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
                  | UNDERSCORE ->
                      _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LPAR ->
                      _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LCUR ->
                      _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | LBRA ->
                      _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_180 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState180 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_208 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos_0) in
      let _v = _menhir_action_211 _2 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_211 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _menhir_s = MenhirState213 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v ->
                  _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UNDERSCORE ->
                  _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_225 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_argsty (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | YIELDS ->
          let _menhir_s = MenhirState227 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_200 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty _menhir_cell0_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LCUR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_4, _endpos__5_) = (_v, _endpos_0) in
      let _v = _menhir_action_213 _1 _4 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_406 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState407
          | COMMA | RPAR ->
              let _v_1 = _menhir_action_164 () in
              _menhir_run_408 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_408 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _, _5, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _7 = _v in
      let _v = _menhir_action_029 _3 _5 _7 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_347 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState348
          | COMMA | RPAR ->
              let _v_1 = _menhir_action_164 () in
              _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_349 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _, _4, _, _) = _menhir_stack in
      let MenhirCell1_optvar (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_032 _2 _4 _6 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_333 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_s = MenhirState335 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VARLPAR _v ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VARLBRA _v ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TRY ->
                  _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TIME _v ->
                  _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | STRING _v ->
                  _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | REGEXP _v ->
                  _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | NOT ->
                  _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INTERVAL _v ->
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | INT _v ->
                  _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | IF ->
                  _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | GET ->
                  _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FUN ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FOR ->
                  _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FLOAT _v ->
                  _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ENCODER _v ->
                  _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BOOL _v ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BEGIN ->
                  _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_229 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
          | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v_1 = _menhir_action_119 () in
              _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState230 _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_232 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState232
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState232
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState232
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState232
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState232
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState232
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | LETLBRA _v_6 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState232
      | LET _v_7 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState232
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | INTERVAL _v_8 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState232
      | INT _v_9 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState232
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | FLOAT _v_10 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState232
      | ENCODER _v_11 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState232
      | DEF _v_12 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState232
      | BOOL _v_13 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState232
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | _ ->
          _eRR ()
  
  and _menhir_run_228 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_argsty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RBRA | RCUR | RPAR | TIMES ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_argsty (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_5, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_210 _2 _5 _endpos__5_ _startpos__1_ in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_223 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_argty as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_047 _1 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_argty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_argty (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState222
          | VAR _v_1 ->
              _menhir_run_174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState222
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | QUESTION ->
              _menhir_run_211 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
          | RPAR ->
              let _v_2 = _menhir_action_044 () in
              _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_045 _1 in
          _menhir_goto_argsty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_224 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_argty -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_argty (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_046 _1 _3 in
      _menhir_goto_argsty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_argsty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState173 ->
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState222 ->
          _menhir_run_224 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_220 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ty _menhir_cell0_TIMES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let MenhirCell0_TIMES (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_237 _1 _3 in
          _menhir_goto_ty_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_218 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_TIMES (_menhir_stack, _startpos, _endpos) in
      let _menhir_s = MenhirState218 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_tuple : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState218 ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState173 ->
          _menhir_run_215 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_219 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty _menhir_cell0_TIMES -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_TIMES (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_238 _1 _3 in
      _menhir_goto_ty_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_215 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_209 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_217 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_047 _1 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_214 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_QUESTION _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_049 _2 _4 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_210 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_048 _1 _3 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_207 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_159 _1 _3 in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_meth_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_1 ->
              _menhir_run_177 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState203
          | STRING _v_2 ->
              _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState203
          | RCUR ->
              let _v_3 =
                let _endpos__0_ = _endpos_0 in
                _menhir_action_187 _endpos__0_
              in
              _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_3
          | _ ->
              _eRR ())
      | RCUR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_188 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_record_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_204 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_ty -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v ->
      let MenhirCell1_meth_ty (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_189 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_record_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s
  
  and _menhir_goto_record_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s ->
      match _menhir_s with
      | MenhirState176 ->
          _menhir_run_208 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState203 ->
          _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v
      | MenhirState191 ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_205 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell0_QUESTION (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_160 _1 _4 in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_199 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_5, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_161 _1 _2 _3 _5 _endpos__5_ _startpos__1_ in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_197 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell0_QUESTION (_menhir_stack, _) = _menhir_stack in
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__6_, _6) = (_endpos, _v) in
          let _v = _menhir_action_162 _1 _2 _3 _6 _endpos__6_ _startpos__1_ in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_182 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_1 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v_4 ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | DOT ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VAR _v_7 ->
                          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
                          let (_2, _5, _4, _7, _endpos__7_) = (_v, _v_4, _v_1, _v_7, _endpos_9) in
                          let _v = _menhir_action_208 _2 _4 _5 _7 _endpos__7_ _startpos__1_ in
                          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | COMMA | DOT | QUESTION | RBRA | RCUR | RPAR | TIMES ->
              let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
              let (_2, _endpos__3_) = (_v, _endpos_0) in
              let _v = _menhir_action_207 _2 _endpos__3_ _startpos__1_ in
              _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_167 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_ty_content -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_ty_content (_menhir_stack, _3) = _menhir_stack in
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_236 _1 _3 _5 in
      _menhir_goto_ty_source_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_156 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_219 _1 _3 _4 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_148 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_218 _1 _2 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_pattern_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState330 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState087 ->
          _menhir_run_126 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_126 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_203 _2 in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_tuple_pattern (_menhir_stack, _menhir_s, _v) in
              let _menhir_s = MenhirState104 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LCUR ->
                  _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | BEGIN | BOOL _ | COLON | COMMA | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _1 = _v in
              let _v = _menhir_action_168 _1 in
              _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_111 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState111 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState099
      | UNDERSCORE ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState099
      | LPAR ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState099
      | LCUR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState099
      | LBRA ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState099
      | DOTDOTDOT ->
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState099
      | COMMA | RBRA ->
          let _v = _menhir_action_171 () in
          _menhir_run_121 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState099 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState100
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | COMMA | RBRA ->
          let _v = _menhir_action_197 () in
          _menhir_goto_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_spread : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState122 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_123 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_spread (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState124
          | UNDERSCORE ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | LPAR ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | LCUR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | LBRA ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | COMMA | RBRA ->
              let _v_1 = _menhir_action_171 () in
              _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState124 _tok
          | _ ->
              _eRR ())
      | RBRA ->
          let MenhirCell1_pattern_list (_menhir_stack, _, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_177 _1 _3 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_125 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list, ttv_result) _menhir_cell1_spread as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RBRA ->
          let MenhirCell1_spread (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_pattern_list (_menhir_stack, _, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_178 _1 _3 _5 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_goto_pattern_list_with_spread : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_144 _2 in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_list_pattern (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState116 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | BEGIN | BOOL _ | COLON | COMMA | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _1 = _v in
          let _v = _menhir_action_169 _1 in
          _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_106 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_spread (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState107
          | UNDERSCORE ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | LPAR ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | LCUR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | LBRA ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState107
          | COMMA | RBRA ->
              let _v_1 = _menhir_action_171 () in
              _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState107 _tok
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_174 _1 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_110 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_spread as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_111 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RBRA ->
          let MenhirCell1_spread (_menhir_stack, _, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_176 _1 _3 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_121 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState122 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOTDOTDOT ->
              _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_175 _1 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_133 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState134 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_172 _1 in
          _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_152 _1 _3 in
      _menhir_goto_meth_pattern_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_meth_pattern_el : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState130 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState078 ->
          _menhir_run_129 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState096 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_129 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState130
          | RCUR ->
              let _v_1 = _menhir_action_153 () in
              _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              _eRR ())
      | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_154 _1 in
          _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_098 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_pattern_el -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_155 _1 _3 in
      _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_meth_pattern_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState130 ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState096 ->
          _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState078 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState088 ->
          _menhir_run_093 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_093 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_185 _2 in
      _menhir_goto_record_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_record_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState116 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState070 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState325 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState330 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState132 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState080 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState087 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState122 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState099 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState111 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState107 ->
          _menhir_run_109 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState104 ->
          _menhir_run_105 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState085 ->
          _menhir_run_086 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState327 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState073 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState082 ->
          _menhir_run_083 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_117 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_list_pattern -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_list_pattern (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_150 _1 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_109 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_146 _1 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_105 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_tuple_pattern -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_tuple_pattern (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_149 _1 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_086 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNDERSCORE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_148 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_083 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_147 _1 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_095 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState096
          | DOTDOTDOT ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState096
          | RCUR ->
              let _v_1 = _menhir_action_153 () in
              _menhir_run_098 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              _eRR ())
      | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_154 _1 in
          _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_118 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_172 _1 in
      _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_112 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_173 _1 _3 in
      _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_113 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_239 _1 in
      let _1 = _v in
      let _v = _menhir_action_167 _1 in
      _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_375 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_subfield as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState375
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState375
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState375
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState375
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState375
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState375
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | LETLBRA _v_6 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState375
      | LET _v_7 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState375
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | INTERVAL _v_8 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState375
      | INT _v_9 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState375
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | FLOAT _v_10 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState375
      | ENCODER _v_11 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState375
      | DEF _v_12 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState375
      | BOOL _v_13 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState375
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState375
      | _ ->
          _eRR ()
  
  and _menhir_run_362 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos) in
          let _v = _menhir_action_034 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_337 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState338 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_295 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos) in
          let _v = _menhir_action_025 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_077 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_125 _1 _3 in
      _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_encoder_param : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_encoder_param (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState393
          | STRING _v_1 ->
              _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState393
          | ENCODER _v_2 ->
              _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState393
          | RPAR ->
              let _v_3 = _menhir_action_059 () in
              _menhir_run_394 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_060 _1 in
          _menhir_goto_encoder_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_385 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_STRING (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState386 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_057 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_388 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
      | COMMA | RPAR ->
          let _v_0 = _menhir_action_052 () in
          _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_389 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENCODER -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_058 _1 _2 in
      _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_394 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_encoder_param -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_encoder_param (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_061 _1 _3 in
      _menhir_goto_encoder_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_encoder_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState502 ->
          _menhir_run_503 _menhir_stack _v
      | MenhirState393 ->
          _menhir_run_394 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState064 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_390 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_053 _2 in
      _menhir_goto_encoder_opt _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_goto_encoder_opt : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState063 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState388 ->
          _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_395 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENCODER -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_081 _1 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_401 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR, ttv_result) _menhir_cell1_GETS, ttv_result) _menhir_cell1_UNDERSCORE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_UNDERSCORE (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_GETS (_menhir_stack, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_030 _2 _5 _endpos__2_ _startpos__2_ in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_402 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_VAR (_menhir_stack, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_028 _2 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_let_opt_el : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_let_opt_el (_menhir_stack, _menhir_s, _v) in
          let _menhir_s = MenhirState416 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_140 _1 in
          _menhir_goto_let_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_let_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState047 ->
          _menhir_run_418 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState416 ->
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_418 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LETLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LETLBRA (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_007 _1 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto__let _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_417 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_let_opt_el -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_let_opt_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_141 _1 _3 in
      _menhir_goto_let_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_432 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState432 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_438 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos_0) in
      let _v = _menhir_action_240 _2 in
      _menhir_goto_varlist _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_varlist : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState483 ->
          _menhir_run_484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState506 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState025 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState027 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState029 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState480 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState475 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState036 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState037 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState467 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState461 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState458 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState454 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState040 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState446 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState444 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState442 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState042 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState435 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState432 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState427 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState425 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState423 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState421 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState049 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState411 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState056 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState058 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState061 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState386 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState066 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState375 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState341 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState338 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState335 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState323 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState312 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState303 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState299 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState243 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState268 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState266 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState264 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState262 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState260 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState258 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState256 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState254 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState252 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState247 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState245 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState240 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState238 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState236 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_484 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_varlist (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DO ->
          let _menhir_s = MenhirState485 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_233 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_457 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | TIMES ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | SET ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | SEQ ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | QUESTION_DOT ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | QUESTION ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | MINUS ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | DOT ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | COLONCOLON ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | COALESCE ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState457
      | BINB _v_0 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState457
      | BIN3 _v_1 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState457
      | BIN2 _v_2 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState457
      | BIN1 _v_3 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState457
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_4 = _menhir_action_190 () in
          _menhir_run_458 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_4 MenhirState457 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_240 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TIMES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState240 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_247 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_SET (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState247 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_318 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_191 () in
      _menhir_goto_s _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_s : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState474 ->
          _menhir_run_475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState460 ->
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState457 ->
          _menhir_run_458 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState443 ->
          _menhir_run_444 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState322 ->
          _menhir_run_323 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState317 ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_475 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState475
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState475
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState475
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState475
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState475
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState475
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | LETLBRA _v_6 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState475
      | LET _v_7 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState475
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | INTERVAL _v_8 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState475
      | INT _v_9 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState475
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | FLOAT _v_10 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState475
      | ENCODER _v_11 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState475
      | DEF _v_12 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState475
      | BOOL _v_13 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState475
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState475
      | _ ->
          _eRR ()
  
  and _menhir_run_461 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_explicit_binding as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState461
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState461
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState461
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState461
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState461
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState461
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | LETLBRA _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState461
      | LET _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState461
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | INTERVAL _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState461
      | INT _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState461
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | FLOAT _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState461
      | ENCODER _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState461
      | DEF _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState461
      | BOOL _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState461
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState461
      | RCUR ->
          let MenhirCell1_explicit_binding (_menhir_stack, _, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_195 _1 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_simple_fun_body : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_097 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_458 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState458
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState458
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState458
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState458
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState458
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState458
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | LETLBRA _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState458
      | LET _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState458
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | INTERVAL _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState458
      | INT _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState458
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | FLOAT _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState458
      | ENCODER _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState458
      | DEF _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState458
      | BOOL _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState458
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState458
      | RCUR ->
          let MenhirCell1_expr (_menhir_stack, _, _1, _, _) = _menhir_stack in
          let _v = _menhir_action_193 _1 in
          _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_444 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState444
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState444
      | VAR _v_2 ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState444
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState444
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState444
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState444
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | LETLBRA _v_6 ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState444
      | LET _v_7 ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState444
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | INTERVAL _v_8 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState444
      | INT _v_9 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState444
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | FLOAT _v_10 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState444
      | ENCODER _v_11 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState444
      | DEF _v_12 ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState444
      | BOOL _v_13 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState444
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState444
      | _ ->
          _eRR ()
  
  and _menhir_run_323 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState323
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState323
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState323
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState323
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState323
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState323
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | LETLBRA _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState323
      | LET _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState323
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | INTERVAL _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState323
      | INT _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState323
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | FLOAT _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState323
      | ENCODER _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState323
      | DEF _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState323
      | BOOL _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState323
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
      | CATCH | ELSE | ELSIF | END | EOF | RCUR | SEQSEQ | THEN ->
          let MenhirCell1_binding (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_117 _1 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_exprs : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState506 ->
          _menhir_run_510 _menhir_stack _v _tok
      | MenhirState023 ->
          _menhir_run_499 _menhir_stack _v _tok
      | MenhirState494 ->
          _menhir_run_495 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState485 ->
          _menhir_run_486 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState480 ->
          _menhir_run_481 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState030 ->
          _menhir_run_477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState475 ->
          _menhir_run_476 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState461 ->
          _menhir_run_462 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState458 ->
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState444 ->
          _menhir_run_445 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState427 ->
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState425 ->
          _menhir_run_426 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState423 ->
          _menhir_run_424 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState421 ->
          _menhir_run_422 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_420 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_398 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState068 ->
          _menhir_run_382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState379 ->
          _menhir_run_380 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState375 ->
          _menhir_run_376 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState368 ->
          _menhir_run_369 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState323 ->
          _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState319 ->
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState232 ->
          _menhir_run_315 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_495 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WHILE, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_WHILE (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__4_, _startpos__4_, _4, _endpos__5_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_098 _2 _4 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__2_ _startpos__4_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_486 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_varlist -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_varlist (_menhir_stack, _, _6, _, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _startpos__4_, _endpos__4_) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__8_, _startpos__8_, _8, _endpos__9_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_102 _2 _4 _6 _8 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__8_ _endpos__9_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__8_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_481 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _startpos__4_, _endpos__4_) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__6_, _startpos__6_, _6, _endpos__7_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_103 _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__6_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_477 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TRY as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | CATCH ->
          let _menhir_s = MenhirState478 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_053 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_476 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_114 _2 _4 _endpos__4_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_462 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_explicit_binding, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_explicit_binding (_menhir_stack, _, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_196 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_459 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_194 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_445 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_OPEN (_menhir_stack, _, _startpos__1_) = _menhir_stack in
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_192 _2 _4 _endpos__4_ _startpos__1_ in
      _menhir_goto_simple_fun_body _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_428 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let MenhirCell1_ELSE (_menhir_stack, _menhir_s) = _menhir_stack in
      let (_endpos__2_, _startpos__2_, _2) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_122 _2 _endpos__2_ _startpos__2_ in
      _menhir_goto_if_elsif _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
  
  and _menhir_goto_if_elsif : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState422 ->
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState426 ->
          _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_430 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _4, _, _endpos__4_) = _menhir_stack in
          let MenhirCell0_THEN (_menhir_stack, _startpos__3_) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__6_, _5) = (_endpos_0, _v) in
          let _v = _menhir_action_104 _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__6_ _startpos__1_ _startpos__3_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_429 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_exprs (_menhir_stack, _, _4, _, _endpos__4_) = _menhir_stack in
      let MenhirCell0_THEN (_menhir_stack, _startpos__3_) = _menhir_stack in
      let MenhirCell1_exprs (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_ELSIF (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_5, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_121 _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__3_ in
      _menhir_goto_if_elsif _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _v _menhir_s _tok
  
  and _menhir_run_426 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | ELSIF ->
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState426
      | ELSE ->
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState426
      | END ->
          let _v_0 =
            let _endpos__0_ = _endpos in
            _menhir_action_123 _endpos__0_
          in
          _menhir_run_429 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_423 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ELSIF (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState423 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_427 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ELSE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState427 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LETLBRA _v ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LET _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | DEF _v ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_424 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | THEN ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_THEN (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState425 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_422 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | ELSIF ->
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState422
      | ELSE ->
          _menhir_run_427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState422
      | END ->
          let _v_0 =
            let _endpos__0_ = _endpos in
            _menhir_action_123 _endpos__0_
          in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_420 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | THEN ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_THEN (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState421 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_398 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__6_, _startpos__6_, _6, _endpos__7_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_099 _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__6_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_382 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_BEGIN -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_BEGIN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_095 _2 in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_380 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_pattern (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_065 _1 _2 _4 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_explicit_binding : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState040 ->
          _menhir_run_460 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState506 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState494 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState485 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState480 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState475 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState461 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState458 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState444 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState046 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState421 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState423 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState425 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState427 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState397 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState068 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState379 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState375 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState368 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState323 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState319 ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_460 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_explicit_binding (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEQ ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_190 () in
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 MenhirState460 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_321 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_051 _1 in
      _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_binding : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_binding (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEQ ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState322
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_0 = _menhir_action_190 () in
          _menhir_run_323 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 MenhirState322 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_376 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_subfield, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_subfield (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_067 _1 _2 _4 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_369 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_arglist (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_varlpar (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_6, _endpos__7_) = (_v, _endpos_0) in
          let _v = _menhir_action_068 _1 _2 _3 _6 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_324 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_binding (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_118 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_320 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_116 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_315 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _, _5, _, _) = _menhir_stack in
          let MenhirCell1_pattern (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_8, _endpos__9_) = (_v, _endpos_0) in
          let _v = _menhir_action_066 _1 _3 _5 _8 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_319 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState319
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState319
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState319
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | TIME _v_3 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState319
      | STRING _v_4 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState319
      | REGEXP _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState319
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | LETLBRA _v_6 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState319
      | LET _v_7 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState319
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | INTERVAL _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState319
      | INT _v_9 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState319
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | FLOAT _v_10 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState319
      | ENCODER _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState319
      | DEF _v_12 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState319
      | BOOL _v_13 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState319
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | CATCH | ELSE | ELSIF | END | EOF | RCUR | SEQSEQ | THEN ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_115 _1 in
          _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_249 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_QUESTION_DOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState249 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_250 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_243 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState243
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState243
      | VAR _v_2 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState243
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | TIME _v_3 ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState243
      | STRING _v_4 ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState243
      | REGEXP _v_5 ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState243
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | INTERVAL _v_6 ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState243
      | INT _v_7 ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState243
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | FLOAT _v_8 ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState243
      | ENCODER _v_9 ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState243
      | BOOL _v_10 ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState243
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | ARGS_OF ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | RPAR ->
          let _v_11 = _menhir_action_019 () in
          _menhir_run_301 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11
      | _ ->
          _eRR ()
  
  and _menhir_run_250 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_138 _1 in
      _menhir_goto_invoke _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_252 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _endpos) in
      let _menhir_s = MenhirState252 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_254 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_MINUS (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState254 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_242 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_DOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState242 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_s = MenhirState303 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | VAR _v ->
          _menhir_run_250 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LCUR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _menhir_s = MenhirState306 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | GETS ->
                  _menhir_run_042 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_256 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_COLONCOLON (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState256 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_262 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COALESCE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState262 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_264 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BINB (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState264 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_258 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BIN3 (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState258 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_266 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BIN2 (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState266 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_268 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BIN1 (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState268 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_364 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | COMMA | RPAR ->
          let _v_0 = _menhir_action_164 () in
          _menhir_run_365 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_365 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_optvar (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_031 _1 _2 _endpos__1_ _startpos__1_ in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_345 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_s = MenhirState346 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_235 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState236 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_101 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_198 _2 in
      _menhir_goto_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_090 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_157 _2 in
      _menhir_goto_meth_spread_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_060 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState061 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_489 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VARLBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_093 _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState489
      | BINB _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState489
      | BIN3 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState489
      | BIN2 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState489
      | BIN1 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState489
      | _ ->
          _eRR ()
  
  and _menhir_run_488 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UMINUS -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_UMINUS (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_070 _2 _endpos__1_ _endpos__2_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_474 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | TIMES ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | SET ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | SEQ ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | QUESTION_DOT ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | QUESTION ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | MINUS ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | DOT ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | COLONCOLON ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | COALESCE ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState474
      | BINB _v_0 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState474
      | BIN3 _v_1 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState474
      | BIN2 _v_2 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState474
      | BIN1 _v_3 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState474
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_4 = _menhir_action_190 () in
          _menhir_run_475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_4 MenhirState474 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_473 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState473
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState473
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState473
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState473
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState473
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState473
      | BEGIN | BIN1 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_073 _2 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_469 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState469
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState469
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState469
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState469
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState469
      | RPAR ->
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_133 _1 _3 in
          _menhir_goto_inner_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_467 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState467 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | VAR _v ->
          _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_inner_tuple : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState467 ->
          _menhir_run_468 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState038 ->
          _menhir_run_463 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_468 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_134 _1 _3 in
      _menhir_goto_inner_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_463 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_083 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_465 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_071 _2 in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | COLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_stack = MenhirCell1_COLON (_menhir_stack, MenhirState465) in
          let _menhir_s = MenhirState470 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v ->
              _menhir_run_135 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_173 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState465
      | BINB _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState465
      | BIN3 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState465
      | BIN2 _v_5 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState465
      | BIN1 _v_6 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState465
      | _ ->
          _eRR ()
  
  and _menhir_run_455 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record _menhir_cell0_DOTDOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | RCUR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_DOTDOTDOT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_record (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _5) = (_endpos_0, _v) in
          let _v = _menhir_action_086 _2 _5 _endpos__6_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | BINB _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState455
      | BIN3 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState455
      | BIN2 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState455
      | BIN1 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState455
      | _ ->
          _eRR ()
  
  and _menhir_run_447 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_DOTDOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | RCUR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DOTDOTDOT (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos_0) in
          let _v = _menhir_action_085 _3 in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState447
      | BINB _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState447
      | BIN3 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState447
      | BIN2 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState447
      | BIN1 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState447
      | _ ->
          _eRR ()
  
  and _menhir_run_443 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | TIMES ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | SET ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | SEQ ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | QUESTION_DOT ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | QUESTION ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | MINUS ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | DOT ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | COLONCOLON ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | COALESCE ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
      | BINB _v_0 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState443
      | BIN3 _v_1 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState443
      | BIN2 _v_2 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState443
      | BIN1 _v_3 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState443
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_4 = _menhir_action_190 () in
          _menhir_run_444 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_4 MenhirState443 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_440 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState440
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState440
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState440
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState440
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState440
      | COMMA | RCUR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_183 _1 _3 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_record : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState040 ->
          _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState306 ->
          _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_451 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_087 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_record (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | DOTDOTDOT ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _menhir_stack = MenhirCell0_DOTDOTDOT (_menhir_stack, _startpos) in
              let _menhir_s = MenhirState454 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VARLPAR _v ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VARLBRA _v ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | VAR _v ->
                  _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TRY ->
                  _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TIME _v ->
                  _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | STRING _v ->
                  _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | REGEXP _v ->
                  _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | NOT ->
                  _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LCUR ->
                  _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRA ->
                  _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INTERVAL _v ->
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | INT _v ->
                  _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | IF ->
                  _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | GET ->
                  _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FUN ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FOR ->
                  _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FLOAT _v ->
                  _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | ENCODER _v ->
                  _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BOOL _v ->
                  _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | BEGIN ->
                  _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_311 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_s = MenhirState312 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_308 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_084 _1 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_record (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_311 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_437 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState437
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState437
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState437
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState437
      | COMMA | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_132 _1 in
          _menhir_goto_inner_list_item _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_inner_list_item : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_inner_list_item (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | VARLPAR _v_1 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState435
          | VARLBRA _v_2 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState435
          | VAR _v_3 ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState435
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | TIME _v_4 ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState435
          | STRING _v_5 ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState435
          | REGEXP _v_6 ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState435
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | INTERVAL _v_7 ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState435
          | INT _v_8 ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState435
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | FLOAT _v_9 ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState435
          | ENCODER _v_10 ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState435
          | DOTDOTDOT ->
              _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | BOOL _v_11 ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState435
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState435
          | RBRA ->
              let _v_12 = _menhir_action_130 () in
              _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_12
          | _ ->
              _eRR ())
      | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_129 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_inner_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_436 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_inner_list_item -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v ->
      let MenhirCell1_inner_list_item (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_128 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_inner_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s
  
  and _menhir_goto_inner_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s ->
      match _menhir_s with
      | MenhirState043 ->
          _menhir_run_438 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState435 ->
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_433 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState433
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState433
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState433
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState433
      | COMMA | RBRA ->
          let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_131 _2 in
          _menhir_goto_inner_list_item _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_414 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState414
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState414
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState414
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState414
      | COMMA | RBRA ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_143 _1 _3 in
          _menhir_goto_let_opt_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_413 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_GET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState413
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COLONCOLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_079 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_412 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState412
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState412
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState412
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState412
      | BEGIN | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_arglist (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_FUN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _6) = (_endpos, _v) in
          let _v = _menhir_action_096 _3 _6 _endpos__6_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_400 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_GETS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState400
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState400
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState400
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState400
      | COMMA | RPAR ->
          let MenhirCell1_GETS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_163 _2 in
          _menhir_goto_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState407 ->
          _menhir_run_408 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState055 ->
          _menhir_run_402 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState057 ->
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState364 ->
          _menhir_run_365 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState348 ->
          _menhir_run_349 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_396 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | TIMES ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | SET ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | QUESTION_DOT ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | QUESTION ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | MINUS ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | DOT ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | DO ->
          let _menhir_stack = MenhirCell1_DO (_menhir_stack, MenhirState396) in
          let _menhir_s = MenhirState397 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UNDERSCORE ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | OPEN ->
              _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LETLBRA _v ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LET _v ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | DEF _v ->
              _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COLONCOLON ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | COALESCE ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState396
      | BINB _v_14 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState396
      | BIN3 _v_15 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState396
      | BIN2 _v_16 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState396
      | BIN1 _v_17 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState396
      | _ ->
          _eRR ()
  
  and _menhir_run_387 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState387
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState387
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState387
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState387
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState387
      | COMMA | RPAR ->
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_055 _1 _3 in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_384 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState384
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState384
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState384
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState384
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_054 _1 _3 in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_342 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState342
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState342
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState342
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState342
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState342
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_pattern (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_062 _1 _2 _4 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_339 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_subfield as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState339
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState339
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState339
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState339
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState339
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_subfield (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_064 _1 _2 _4 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_336 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState336
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState336
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState336
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState336
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState336
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _, _5, _, _) = _menhir_stack in
          let MenhirCell1_pattern (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__8_, _8) = (_endpos, _v) in
          let _v = _menhir_action_063 _1 _3 _5 _8 in
          _menhir_goto_explicit_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__8_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_317 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | TIMES ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | SET ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | SEQ ->
          _menhir_run_318 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | QUESTION_DOT ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | QUESTION ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | MINUS ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | DOT ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | COLONCOLON ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | COALESCE ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState317
      | BINB _v_0 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState317
      | BIN3 _v_1 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState317
      | BIN2 _v_2 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState317
      | BIN1 _v_3 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState317
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v_4 = _menhir_action_190 () in
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_4 MenhirState317 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_313 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LCUR, ttv_result) _menhir_cell1_record _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState313
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState313
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState313
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState313
      | COMMA | RCUR ->
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell1_record (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_184 _1 _3 _5 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_304 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT, ttv_result) _menhir_cell1_VARLBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _endpos__3_) = _menhir_stack in
          let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_094 _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
      | BINB _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState304
      | BIN3 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState304
      | BIN2 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState304
      | BIN1 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState304
      | _ ->
          _eRR ()
  
  and _menhir_run_297 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState297
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState297
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState297
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState297
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_023 _1 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_269 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN1 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState269
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState269
      | BEGIN | BIN1 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN1 (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_108 _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_267 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN2 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState267
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState267
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState267
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState267
      | BEGIN | BIN1 _ | BIN2 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN2 (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_109 _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_265 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BINB as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState265
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState265
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState265
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState265
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState265
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState265
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState265
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState265
      | BEGIN | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BINB (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__3_, _startpos__3_, _3) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_107 _1 _2 _3 _endpos__1_ _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ _startpos__3_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_263 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COALESCE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState263
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState263
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState263
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState263
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState263
      | BEGIN | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_COALESCE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_101 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_261 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let MenhirCell1_COLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _3, _startpos__3_, _endpos__3_) = _menhir_stack in
      let MenhirCell1_QUESTION (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_5, _endpos__5_, _startpos__5_) = (_v, _endpos, _startpos) in
      let _v = _menhir_action_106 _1 _3 _5 _endpos__1_ _endpos__3_ _endpos__5_ _startpos__1_ _startpos__3_ _startpos__5_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_259 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN3 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState259
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN3 (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_110 _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_257 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLONCOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState257
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState257
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_COLONCOLON (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_092 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_255 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_MINUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState255
      | BEGIN | BIN1 _ | BIN2 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_MINUS (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_112 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_253 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | TIMES ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | SET ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | QUESTION_DOT ->
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | QUESTION ->
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | MINUS ->
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | DOT ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | COLONCOLON ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | COLON ->
          let _menhir_stack = MenhirCell1_COLON (_menhir_stack, MenhirState253) in
          let _menhir_s = MenhirState260 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | VAR _v ->
              _menhir_run_028 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRY ->
              _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TIME _v ->
              _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING _v ->
              _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | REGEXP _v ->
              _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | NOT ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LCUR ->
              _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRA ->
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTERVAL _v ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INT _v ->
              _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | IF ->
              _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | GET ->
              _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUN ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT _v ->
              _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | ENCODER _v ->
              _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BOOL _v ->
              _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BEGIN ->
              _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | COALESCE ->
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState253
      | BINB _v_11 ->
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState253
      | BIN3 _v_12 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState253
      | BIN2 _v_13 ->
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState253
      | BIN1 _v_14 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState253
      | _ ->
          _eRR ()
  
  and _menhir_run_248 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState248
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState248
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState248
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState248
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState248
      | BEGIN | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_SET (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_080 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_246 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState246
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState246
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState246
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState246
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_022 _1 _3 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_241 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TIMES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | QUESTION_DOT | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_TIMES (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_111 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_239 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TO as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState239
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState239
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState239
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState239
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState239
      | BEGIN | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_TO (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_100 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_237 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | QUESTION_DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_264 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState237
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState237
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_266 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState237
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState237
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RCUR | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_optvar (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_050 _1 _3 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_023 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LETLBRA _v ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | LET _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | EOF ->
          let _v = _menhir_action_137 () in
          _menhir_goto_interactive _menhir_stack _v
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | DEF _v ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | _ ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_135 _endpos__1_ _startpos__1_ in
          MenhirBox_interactive _v
  
  let _menhir_run_501 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_plain_encoder_params =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState502
          | STRING _v ->
              _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState502
          | ENCODER _v ->
              _menhir_run_388 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState502
          | RPAR ->
              let _v = _menhir_action_059 () in
              _menhir_run_503 _menhir_stack _v
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let _menhir_run_506 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | VAR _v ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | UNDERSCORE ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | TRY ->
          _menhir_run_030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | TIME _v ->
          _menhir_run_033 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | STRING _v ->
          _menhir_run_034 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | REGEXP _v ->
          _menhir_run_035 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | OPEN ->
          _menhir_run_036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | NOT ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | LPAR ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | LETLBRA _v ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | LET _v ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | LCUR ->
          _menhir_run_040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | LBRA ->
          _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | INTERVAL _v ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | INT _v ->
          _menhir_run_045 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | IF ->
          _menhir_run_046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | GET ->
          _menhir_run_050 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | FUN ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | FOR ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | FLOAT _v ->
          _menhir_run_062 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | EOF ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_181 _endpos__1_ _startpos__1_ in
          _menhir_goto_program _menhir_stack _v
      | ENCODER _v ->
          _menhir_run_063 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | DEF _v ->
          _menhir_run_070 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | BOOL _v ->
          _menhir_run_067 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState506
      | BEGIN ->
          _menhir_run_068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState506
      | _ ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_180 _endpos__1_ _startpos__1_ in
          MenhirBox_program _v
  
  let _menhir_run_512 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_time_predicate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _v =
            let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
            _menhir_action_202 _1 _endpos__1_ _startpos__1_
          in
          _menhir_run_515 _menhir_stack _v
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _v =
            let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
            _menhir_action_201 _1 _endpos__1_ _startpos__1_
          in
          _menhir_run_515 _menhir_stack _v
      | _ ->
          _eRR ()
  
end

let time_predicate =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_time_predicate v = _menhir_run_512 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let program =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_program v = _menhir_run_506 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let plain_encoder_params =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_plain_encoder_params v = _menhir_run_501 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let interactive =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_interactive v = _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let annotate_metadata_entry =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_annotate_metadata_entry v = _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let annotate =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_annotate v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
